/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)cdr_encapsulation.h    generated by: makeheader    Sat Mar  9 09:37:57 2024
 *
 *		built from:	encapsulation.ifc
 */

#ifndef cdr_encapsulation_h
#define cdr_encapsulation_h



#ifndef cdr_dll_h
#include "cdr/cdr_dll.h"
#endif

#ifndef osapi_type_h
#include "osapi/osapi_type.h"
#endif

#include "xcdr/xcdr_stream.h"

/* For VxWorks defines */
#ifdef RTI_VXWORKS
#include <vxWorks.h>
#endif

#ifdef __cplusplus
    extern "C" {
#endif


/* OMG CDR Big Endian */
#define RTI_CDR_ENCAPSULATION_ID_CDR_BE     RTI_XCDR_ENCAPSULATION_ID_CDR_BE
/* OMG CDR Little Endian */
#define RTI_CDR_ENCAPSULATION_ID_CDR_LE     RTI_XCDR_ENCAPSULATION_ID_CDR_LE
/* Parameter List OMG CDR Big Endian */
#define RTI_CDR_ENCAPSULATION_ID_PL_CDR_BE  RTI_XCDR_ENCAPSULATION_ID_PL_CDR_BE
/* Parameter List OMG CDR Little Endian */
#define RTI_CDR_ENCAPSULATION_ID_PL_CDR_LE  RTI_XCDR_ENCAPSULATION_ID_PL_CDR_LE

#define RTI_CDR_ENCAPSULATION_ID_CDR2_BE    RTI_XCDR_ENCAPSULATION_ID_CDR2_BE
#define RTI_CDR_ENCAPSULATION_ID_CDR2_LE    RTI_XCDR_ENCAPSULATION_ID_CDR2_LE
#define RTI_CDR_ENCAPSULATION_ID_D_CDR2_BE  RTI_XCDR_ENCAPSULATION_ID_D_CDR2_BE
#define RTI_CDR_ENCAPSULATION_ID_D_CDR2_LE  RTI_XCDR_ENCAPSULATION_ID_D_CDR2_LE
#define RTI_CDR_ENCAPSULATION_ID_PL_CDR2_BE RTI_XCDR_ENCAPSULATION_ID_PL_CDR2_BE
#define RTI_CDR_ENCAPSULATION_ID_PL_CDR2_LE RTI_XCDR_ENCAPSULATION_ID_PL_CDR2_LE

/* #define RTI_CDR_ENCAPSULATION_ID_CDR_NATIVE 0x0004 */
/* #define RTI_CDR_ENCAPSULATION_ID_PL_CDR_NATIVE  0x0005 */

#define RTI_CDR_ENCAPSULATION_ID_INVALID 0xFFFFU

#define RTI_CDR_ENCAPSULATION_ID_ALREADY_PROCESSED 0xFFFE

#define RTI_CDR_ENCAPSULATION_OPTIONS_NONE  RTI_XCDR_ENCAPSULATION_OPTIONS_NONE

#define RTI_CDR_ENCAPSULATION_HEADER_SIZE   RTI_XCDR_ENCAPSULATION_HEADER_SIZE

#define RTI_CDR_COMPRESSION_HEADER_SIZE  RTI_XCDR_COMPRESSION_HEADER_SIZE

/* {parameterId, parameterLength}. Used for inlineQos ParameterList. */
#define RTI_CDR_PARAMETER_SHORT_HEADER_SIZE 4
#define RTI_CDR_SHORT_PARAMETER_LENGTH 2
#define RTI_CDR_ENCAPSULATION_ID_SIZE RTI_XCDR_ENCAPSULATION_ID_SIZE
#define RTI_CDR_ENCAPSULATION_OPTIONS_SIZE RTI_XCDR_ENCAPSULATION_OPTIONS_SIZE

#ifdef RTI_ENDIAN_LITTLE
  #define RTI_CDR_ENCAPSULATION_ID_CDR_NATIVE   RTI_CDR_ENCAPSULATION_ID_CDR_LE
  #define RTI_CDR_ENCAPSULATION_ID_PL_CDR_NATIVE   RTI_CDR_ENCAPSULATION_ID_PL_CDR_LE
  #define RTI_CDR_ENCAPSULATION_ID_CDR2_NATIVE   RTI_CDR_ENCAPSULATION_ID_CDR2_LE
  #define RTI_CDR_ENCAPSULATION_ID_PL_CDR2_NATIVE   RTI_CDR_ENCAPSULATION_ID_PL_CDR2_LE
  #define RTI_CDR_ENCAPSULATION_ID_D_CDR2_NATIVE RTI_CDR_ENCAPSULATION_ID_D_CDR2_LE
#else
  #define RTI_CDR_ENCAPSULATION_ID_CDR_NATIVE   RTI_CDR_ENCAPSULATION_ID_CDR_BE
  #define RTI_CDR_ENCAPSULATION_ID_PL_CDR_NATIVE   RTI_CDR_ENCAPSULATION_ID_PL_CDR_BE
  #define RTI_CDR_ENCAPSULATION_ID_CDR2_NATIVE   RTI_CDR_ENCAPSULATION_ID_CDR2_BE
  #define RTI_CDR_ENCAPSULATION_ID_PL_CDR2_NATIVE   RTI_CDR_ENCAPSULATION_ID_PL_CDR2_BE
  #define RTI_CDR_ENCAPSULATION_ID_D_CDR2_NATIVE RTI_CDR_ENCAPSULATION_ID_D_CDR2_BE
#endif

/* Vendor specific encapsulation IDs start from 0xC000 */
#define RTI_ENCAPSULATION_ID_SHMEM_REF_PLAIN    0xC000
#define RTI_ENCAPSULATION_ID_SHMEM_REF_FLAT_DATA    0xC001


typedef RTI_UINT16 RTIEncapsulationId;

typedef RTI_UINT16 RTIEncapsulationOptions;

extern RTICdrDllExport 
RTIBool RTICdrEncapsulation_validPlainCdrEncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport 
RTIBool RTICdrEncapsulation_validParameterCdrEncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport 
RTIBool RTICdrEncapsulation_validDelimitedCdrEncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport 
RTIBool RTICdrEncapsulation_validCdrV1EncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport
RTIBool RTICdrEncapsulation_validCdrV2EncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport
RTIBool RTICdrEncapsulation_validCdrEncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport
RTIBool RTICdrEncapsulation_validShmemRefEncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport
RTIBool RTICdrEncapsulation_validEncapsulationId(
        RTIEncapsulationId identifer);

extern RTICdrDllExport 
RTIEncapsulationId RTICdrEncapsulation_getNativeCdrEncapsulationId(void);

extern RTICdrDllExport
RTIEncapsulationId RTICdrEncapsulation_getParameterCdrEncapsulationId(
        RTIEncapsulationId plainCdrEncapsulationId);

extern RTICdrDllExport
RTIBool RTICdrEncapsulation_isLittleEndianCdrEncapsulationId(
        RTIEncapsulationId encapsulationId);

extern RTICdrDllExport
RTIBool RTICdrEncapsulation_isBigEndianCdrEncapsulationId(
        RTIEncapsulationId encapsulationId);

struct RTIEncapsulationInfo {
    RTIEncapsulationId encapsulationId;
    RTIBool getLazy;
    RTIBool returnImmediate;
    RTIBool useZeroCopy;
};


#define RTI_ENCAPSULATION_INFO_DEFAULT \
{ \
   RTI_CDR_ENCAPSULATION_ID_CDR_NATIVE, /* encapsulationId */ \
   RTI_FALSE, /* getLazy */ \
   RTI_FALSE, /* returnImmediate */ \
   RTI_FALSE, /* doZeroCopy */ \
}


#define RTI_CDR_PARAMETER_HEADER_ALIGNMENT 4


#define RTI_CDR_PID_NON_EXTENDED_USER_MAX_VALUE 0x3F00


#define RTI_CDR_PID_NON_EXTENDED_ABSOLUTE_MAX_VALUE 0x3FFF


#define RTI_CDR_PID_EXTENDED 0x3F01


#define RTI_CDR_PID_LIST_END 0x3F02


#define RTI_CDR_PID_IGNORE 0x3F03


#define RTI_CDR_PARAMETER_FLAG_IMPL_EXTENSION 0x8000


#define RTI_CDR_PARAMETER_FLAG_MUST_UNDERSTAND 0x4000


#define RTI_CDR_LONG_PARAMETER_FLAG_MUST_UNDERSTAND 0x40000000

extern RTICdrDllExport
void RTICdrParameterId_stripOutFlags(RTI_UINT16 * paramaterId);

extern RTICdrDllExport
void RTICdrLongParameterId_stripOutFlags(RTI_UINT32 * paramaterId);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#include "cdr/cdr_encapsulation_impl.h"


#endif /* cdr_encapsulation_h */
