/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_builtin_trust.h    generated by: makeheader    Sat Mar  9 09:39:07 2024
 *
 *		built from:	builtin_trust.ifc
 */

#ifndef dds_c_builtin_trust_h
#define dds_c_builtin_trust_h


  #include "dds_c/dds_c_infrastructure.h"

#ifdef __cplusplus
    extern "C" {
#endif


#define DDS_ParticipantTrustProtectionInfo_INITIALIZER \
    PRESParticipantTrustProtectionInfo_INITIALIZER

#define DDS_ParticipantTrustProtectionInfo_copy(out__, in__) \
    (out__)->bitmask = (in__)->bitmask; \
    (out__)->plugin_bitmask = (in__)->plugin_bitmask

#define DDS_ParticipantTrustProtectionInfo_equals(out__, in__) \
    ((out__)->bitmask == (in__)->bitmask \
        && (out__)->plugin_bitmask == (in__)->plugin_bitmask)


typedef DDS_UnsignedLong DDS_ParticipantTrustAttributesMask;


typedef DDS_UnsignedLong DDS_PluginParticipantTrustAttributesMask;


typedef struct DDS_ParticipantTrustProtectionInfo {
    /*e \dref_ParticipantTrustProtectionInfo_bitmask
     */
    DDS_ParticipantTrustAttributesMask bitmask;
    /*e \dref_ParticipantTrustProtectionInfo_plugin_bitmask
     */
    DDS_PluginParticipantTrustAttributesMask plugin_bitmask;
} DDS_ParticipantTrustProtectionInfo;


#define DDS_EndpointTrustProtectionInfo_INITIALIZER PRESEndpointTrustProtectionInfo_INITIALIZER

#define DDS_EndpointTrustProtectionInfo_copy(out__, in__) \
    (out__)->bitmask = (in__)->bitmask; \
    (out__)->plugin_bitmask = (in__)->plugin_bitmask

#define DDS_EndpointTrustProtectionInfo_equals(out__, in__) \
    ((out__)->bitmask == (in__)->bitmask \
        && (out__)->plugin_bitmask == (in__)->plugin_bitmask)


typedef DDS_UnsignedLong DDS_EndpointTrustAttributesMask;


typedef DDS_UnsignedLong DDS_PluginEndpointTrustAttributesMask;


typedef DDS_UnsignedLong DDS_VendorEndpointTrustAttributesMask;


typedef struct DDS_EndpointTrustProtectionInfo {
    /*e \dref_EndpointTrustProtectionInfo_bitmask
     */
    DDS_EndpointTrustAttributesMask bitmask;
    /*e \dref_EndpointTrustProtectionInfo_plugin_bitmask
     */
    DDS_PluginEndpointTrustAttributesMask plugin_bitmask;
} DDS_EndpointTrustProtectionInfo;

typedef DDS_UnsignedLong DDS_TrustAlgorithmBit;


#define DDS_TRUST_ALGORITHM_BIT_COMPATIBILITY_MODE \
    PRES_TRUST_ALGORITHM_BIT_COMPATIBILITY_MODE

typedef DDS_UnsignedLong DDS_TrustAlgorithmSet;


#define DDS_TRUST_ALGORITHM_SET_ALL   PRES_TRUST_ALGORITHM_SET_ALL
#define DDS_TRUST_ALGORITHM_SET_EMPTY PRES_TRUST_ALGORITHM_SET_EMPTY


typedef struct DDS_TrustAlgorithmRequirements {
    /*e \dref_TrustAlgorithmRequirements_supported_mask
     */
    DDS_TrustAlgorithmSet supported_mask;
    /*e \dref_TrustAlgorithmRequirements_required_mask
     */
    DDS_TrustAlgorithmSet required_mask;
} DDS_TrustAlgorithmRequirements;


#define DDS_TrustAlgorithmRequirements_INITIALIZER { \
    DDS_TRUST_ALGORITHM_SET_EMPTY, \
    DDS_TRUST_ALGORITHM_SET_EMPTY \
}

#define DDS_TrustAlgorithmRequirements_copy(out__, in__) \
    (out__)->supported_mask = (in__)->supported_mask; \
    (out__)->required_mask = (in__)->required_mask

#define DDS_TrustAlgorithmRequirements_equals(left__, right__) \
    ((left__)->supported_mask == (right__)->supported_mask \
        && (left__)->required_mask == (right__)->required_mask)

typedef struct DDS_ParticipantTrustSignatureAlgorithmInfo {
    /*e \dref_ParticipantTrustSignatureAlgorithmInfo_trust_chain
     */
    DDS_TrustAlgorithmRequirements trust_chain;
    /*e \dref_ParticipantTrustSignatureAlgorithmInfo_message_auth
     */
    DDS_TrustAlgorithmRequirements message_auth;
} DDS_ParticipantTrustSignatureAlgorithmInfo;

typedef struct DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo {
    /*e \dref_ParticipantTrustKeyEstablishmentAlgorithmInfo_shared_secret
     */
    DDS_TrustAlgorithmRequirements shared_secret;
} DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo;

typedef struct DDS_ParticipantTrustInterceptorAlgorithmInfo {
    /*e \dref_ParticipantTrustInterceptorAlgorithmInfo_supported_mask
     */
    DDS_TrustAlgorithmSet supported_mask;
    /*e \dref_ParticipantTrustInterceptorAlgorithmInfo_builtin_endpoints_required_mask
     */
    DDS_TrustAlgorithmSet builtin_endpoints_required_mask;
    /*e \dref_ParticipantTrustInterceptorAlgorithmInfo_builtin_kx_endpoints_required_mask
     */
    DDS_TrustAlgorithmSet builtin_kx_endpoints_required_mask;
    /*e \dref_ParticipantTrustInterceptorAlgorithmInfo_user_endpoints_default_required_mask
     */
    DDS_TrustAlgorithmSet user_endpoints_default_required_mask;
} DDS_ParticipantTrustInterceptorAlgorithmInfo;

typedef struct DDS_ParticipantTrustAlgorithmInfo {
    /*e \dref_ParticipantTrustAlgorithmInfo_signature
     */
    DDS_ParticipantTrustSignatureAlgorithmInfo signature;
    /*e \dref_ParticipantTrustAlgorithmInfo_key_establishment
     */
    DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo key_establishment;
    /*e \dref_ParticipantTrustAlgorithmInfo_interceptor
     */
    DDS_ParticipantTrustInterceptorAlgorithmInfo interceptor;
} DDS_ParticipantTrustAlgorithmInfo;


typedef DDS_UnsignedLong DDS_ParticipantTrustVendorProtectionInfoMask;

typedef struct DDS_ParticipantTrustVendorProtectionInfo {
    /*i \dref_ParticipantTrustVendorProtectionInfo_bitmask
     */
    DDS_ParticipantTrustVendorProtectionInfoMask bitmask;
    /*i \dref_ParticipantTrustVendorProtectionInfo_non_derived_bitmask
     */
    DDS_ParticipantTrustVendorProtectionInfoMask non_derived_bitmask;
} DDS_ParticipantTrustVendorProtectionInfo;



#define DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_TRUST_CHAIN_SUPPORTED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_TRUST_CHAIN_SUPPORTED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_TRUST_CHAIN_REQUIRED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_TRUST_CHAIN_REQUIRED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_MESSAGE_AUTH_SUPPORTED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_MESSAGE_AUTH_SUPPORTED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_MESSAGE_AUTH_REQUIRED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_MESSAGE_AUTH_REQUIRED_MASK_DEFAULT

#define DDS_ParticipantTrustSignatureAlgorithmInfo_INITIALIZER_NOSEC { \
    {0, 0}, \
    {0, 0} \
}

#define DDS_ParticipantTrustSignatureAlgorithmInfo_INITIALIZER_SEC12 { \
    {DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_TRUST_CHAIN_SUPPORTED_MASK_DEFAULT,\
    DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_TRUST_CHAIN_REQUIRED_MASK_DEFAULT}, \
    {DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_MESSAGE_AUTH_SUPPORTED_MASK_DEFAULT, \
    DDS_PARTICIPANT_TRUST_SIGNATURE_ALGORITHM_INFO_MESSAGE_AUTH_REQUIRED_MASK_DEFAULT} \
}

#define DDS_PARTICIPANT_TRUST_KEY_ESTABLISHMENT_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_KEY_ESTABLISHMENT_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_KEY_ESTABLISHMENT_ALGORITHM_INFO_REQUIRED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_KEY_ESTABLISHMENT_ALGORITHM_INFO_REQUIRED_MASK_DEFAULT

#define DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_INITIALIZER_NOSEC { \
    {0, 0} \
}

#define DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_INITIALIZER_SEC12 { \
    {DDS_PARTICIPANT_TRUST_KEY_ESTABLISHMENT_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT, \
    DDS_PARTICIPANT_TRUST_KEY_ESTABLISHMENT_ALGORITHM_INFO_REQUIRED_MASK_DEFAULT} \
}

#define DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_BUILTIN_ENDPOINTS_REQUIRED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_BUILTIN_ENDPOINTS_REQUIRED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_BUILTIN_ENDPOINTS_KEY_EXCHANGE_REQUIRED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_BUILTIN_ENDPOINTS_KEY_EXCHANGE_REQUIRED_MASK_DEFAULT

#define DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_USER_ENDPOINTS_DEFAULT_REQUIRED_MASK_DEFAULT \
    PRES_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_USER_ENDPOINTS_DEFAULT_REQUIRED_MASK_DEFAULT

#define DDS_ParticipantTrustInterceptorAlgorithmInfo_INITIALIZER_NOSEC { \
    0, \
    0, \
    0, \
    0 \
}

#define DDS_ParticipantTrustInterceptorAlgorithmInfo_INITIALIZER_SEC12 { \
    DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT, \
    DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_BUILTIN_ENDPOINTS_REQUIRED_MASK_DEFAULT, \
    DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_BUILTIN_ENDPOINTS_KEY_EXCHANGE_REQUIRED_MASK_DEFAULT, \
    DDS_PARTICIPANT_TRUST_INTERCEPTOR_ALGORITHM_INFO_USER_ENDPOINTS_DEFAULT_REQUIRED_MASK_DEFAULT \
}

#define DDS_PARTICIPANT_TRUST_VENDOR_PROTECTION_INFO_MASK_DEFAULT \
    PRES_VENDOR_PARTICIPANT_SECURITY_PROTECTION_INFO_BITMASK_DEFAULT

/*
 * These are the default flag values without security: it is what we assume when
 * the flags aren't propagated and the Identity Token is not present.
 */
#define DDS_ParticipantTrustAlgorithmInfo_INITIALIZER_NOSEC { \
    DDS_ParticipantTrustSignatureAlgorithmInfo_INITIALIZER_NOSEC, \
    DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_INITIALIZER_NOSEC, \
    DDS_ParticipantTrustInterceptorAlgorithmInfo_INITIALIZER_NOSEC \
}

/*
 * These are the default flag values with security: it is what we assume when
 * the flags aren't propagated and the Identity Token is present.
 */
#define DDS_ParticipantTrustAlgorithmInfo_INITIALIZER_SEC12 { \
    DDS_ParticipantTrustSignatureAlgorithmInfo_INITIALIZER_SEC12, \
    DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_INITIALIZER_SEC12, \
    DDS_ParticipantTrustInterceptorAlgorithmInfo_INITIALIZER_SEC12 \
}

#define DDS_ParticipantTrustVendorProtectionInfo_INITIALIZER { \
    DDS_PARTICIPANT_TRUST_VENDOR_PROTECTION_INFO_MASK_DEFAULT, \
    DDS_PARTICIPANT_TRUST_VENDOR_PROTECTION_INFO_MASK_DEFAULT  \
}

#define DDS_ParticipantTrustSignatureAlgorithmInfo_copy(out__, in__) \
    DDS_TrustAlgorithmRequirements_copy( \
            &(out__)->trust_chain, \
            &(in__)->trust_chain); \
    DDS_TrustAlgorithmRequirements_copy( \
            &(out__)->message_auth, \
            &(in__)->message_auth)

#define DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_copy(out__, in__) \
    DDS_TrustAlgorithmRequirements_copy( \
            &(out__)->shared_secret, \
            &(in__)->shared_secret)

#define DDS_ParticipantTrustInterceptorAlgorithmInfo_copy(out__, in__) \
    (out__)->supported_mask = (in__)->supported_mask; \
    (out__)->builtin_endpoints_required_mask = (in__)->builtin_endpoints_required_mask; \
    (out__)->builtin_kx_endpoints_required_mask = (in__)->builtin_kx_endpoints_required_mask

#define DDS_ParticipantTrustAlgorithmInfo_copy(out__, in__) \
    DDS_ParticipantTrustSignatureAlgorithmInfo_copy( \
        &(out__)->signature, \
        &(in__)->signature); \
    DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_copy( \
        &(out__)->key_establishment, \
        &(in__)->key_establishment); \
    DDS_ParticipantTrustInterceptorAlgorithmInfo_copy( \
        &(out__)->interceptor, \
        &(in__)->interceptor)

#define DDS_ParticipantTrustSignatureAlgorithmInfo_equals(left__, right__) \
    (DDS_TrustAlgorithmRequirements_equals( \
            &(left__)->trust_chain, \
            &(right__)->trust_chain) \
        && DDS_TrustAlgorithmRequirements_equals( \
                &(left__)->message_auth, \
                &(right__)->message_auth))

#define DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_equals(left__, right__) \
    DDS_TrustAlgorithmRequirements_equals( \
            &(left__)->shared_secret, \
            &(right__)->shared_secret)

#define DDS_ParticipantTrustInterceptorAlgorithmInfo_equals(left__, right__) \
    ((left__)->supported_mask == (right__)->supported_mask \
        && (left__)->builtin_endpoints_required_mask \
            == (right__)->builtin_endpoints_required_mask \
        && (left__)->builtin_kx_endpoints_required_mask \
            == (right__)->builtin_kx_endpoints_required_mask \
        && (left__)->user_endpoints_default_required_mask \
            == (right__)->user_endpoints_default_required_mask)

#define DDS_ParticipantTrustAlgorithmInfo_equals(left__, right__) \
    (DDS_ParticipantTrustSignatureAlgorithmInfo_equals( \
        &(left__)->signature, \
        &(right__)->signature) \
        && DDS_ParticipantTrustKeyEstablishmentAlgorithmInfo_equals( \
            &(left__)->key_establishment, \
            &(right__)->key_establishment) \
        && DDS_ParticipantTrustInterceptorAlgorithmInfo_equals( \
            &(left__)->interceptor, \
            &(right__)->interceptor))

/* Macros used to check if a mask is a subset of another */
#define DDS_TrustAlgorithms_isSupportedMaskAllowed(set__, subset__) \
    ((~(set__) & (subset__)) == 0)


typedef struct DDS_EndpointTrustInterceptorAlgorithmInfo {
    /*e \dref_EndpointTrustInterceptorAlgorithmInfo_required_mask
     */
    DDS_TrustAlgorithmSet required_mask;
    /*e \dref_EndpointTrustInterceptorAlgorithmInfo_supported_mask
     */
    DDS_TrustAlgorithmSet supported_mask; /* @non_serialized */
} DDS_EndpointTrustInterceptorAlgorithmInfo;

typedef struct DDS_EndpointTrustAlgorithmInfo {
    /*e \dref_EndpointTrustAlgorithmInfo_interceptor
     */
    DDS_EndpointTrustInterceptorAlgorithmInfo interceptor;
} DDS_EndpointTrustAlgorithmInfo;


#define DDS_EndpointTrustInterceptorAlgorithmInfo_INITIALIZER_NOSEC { \
    0, \
    0 \
}

#define DDS_EndpointTrustInterceptorAlgorithmInfo_INITIALIZER_SEC12 { \
    PRES_ENDPOINT_TRUST_INTERCEPTOR_ALGORITHM_INFO_REQUIRED_MASK_DEFAULT, \
    PRES_ENDPOINT_TRUST_INTERCEPTOR_ALGORITHM_INFO_SUPPORTED_MASK_DEFAULT \
}

#define DDS_EndpointTrustAlgorithmInfo_INITIALIZER_NOSEC { \
    DDS_EndpointTrustInterceptorAlgorithmInfo_INITIALIZER_NOSEC \
}

#define DDS_EndpointTrustAlgorithmInfo_INITIALIZER_SEC12 { \
    DDS_EndpointTrustInterceptorAlgorithmInfo_INITIALIZER_SEC12 \
}

#define DDS_EndpointTrustInterceptorAlgorithmInfo_copy(out__, in__) \
    (out__)->required_mask = (in__)->required_mask; \
    (out__)->supported_mask = (in__)->supported_mask

#define DDS_EndpointTrustInterceptorAlgorithmInfo_equals(left__, right__) \
    (((left__)->required_mask == (right__)->required_mask) \
            && ((left__)->supported_mask == (right__)->supported_mask))

#define DDS_EndpointTrustAlgorithmInfo_copy(out__, in__) \
    DDS_EndpointTrustInterceptorAlgorithmInfo_copy( \
        &(out__)->interceptor, \
        &(in__)->interceptor)

#define DDS_EndpointTrustAlgorithmInfo_equals(left__, right__) \
    DDS_EndpointTrustInterceptorAlgorithmInfo_equals( \
        &(left__)->interceptor, \
        &(right__)->interceptor)

typedef enum {
    DDS_ENDPOINT_NON_PROTECTED_BUILTIN_TOPIC,
    DDS_ENDPOINT_VOLATILE_BUILTIN_TOPIC,
    DDS_ENDPOINT_DISCOVERY_BUILTIN_TOPIC,
    DDS_ENDPOINT_SERVICE_REQUEST_BUILTIN_TOPIC,
    DDS_ENDPOINT_LIVELINESS_BUILTIN_TOPIC,
    DDS_ENDPOINT_INSTANCE_STATE_BUILTIN_TOPIC,
    DDS_ENDPOINT_LOGGING_BUILTIN_TOPIC,
    DDS_ENDPOINT_MONITORING_METRICS_BUILTIN_TOPIC,
    DDS_ENDPOINT_MONITORING_LOGGING_BUILTIN_TOPIC,
    DDS_ENDPOINT_USER_DATA_TOPIC
} DDS_EndpointTopicType;

extern DDSCDllExport
DDS_EndpointTopicType DDS_DomainParticipantTrustPlugins_getEndpointTypeFromName(
        const char *topicName);

extern DDSCDllExport
DDS_EndpointTopicType DDS_DomainParticipantTrustPlugins_getEndpointTypeFromOid(
        MIGRtpsObjectId objectId);


#ifdef __cplusplus
    }   /* extern "C" */
#endif

#endif /* dds_c_builtin_trust_h */
