/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_builtintypes_impl.h    generated by: makeheader    Sat Mar  9 09:39:07 2024
 *
 *		built from:	builtintypes_impl.ifc
 */

#ifndef dds_c_builtintypes_impl_h
#define dds_c_builtintypes_impl_h


  #include "dds_c/dds_c_dll.h"
  #include "dds_c/dds_c_builtintypes.h"

#ifdef __cplusplus
    extern "C" {
#endif


#define DDS_BUILTINTYPES_AUTO_REGISTER_PROPERTY_NAME PROPERTY_NAME_DDS_BUILTIN_TYPE_AUTO_REGISTER

extern DDSCDllExport
struct PRESTypePlugin *DDS_OctetsPlugin_new(void);

extern DDSCDllExport
void DDS_OctetsPlugin_delete(struct PRESTypePlugin *self);

extern DDSCDllExport DDS_Octets *
DDS_OctetsPluginSupport_create_data_ex(RTIBool allocate_pointers);

extern DDSCDllExport DDS_Octets *
DDS_OctetsPluginSupport_create_data(void);

extern DDSCDllExport DDS_Octets *
DDS_OctetsPluginSupport_create_data_w_size_ex(int size, RTIBool allocate_pointers);

extern DDSCDllExport DDS_Octets *
DDS_OctetsPluginSupport_create_data_w_size(int size);

extern DDSCDllExport void 
DDS_OctetsPluginSupport_destroy_data_ex(
    DDS_Octets * sample,RTIBool deallocate_pointers);

extern DDSCDllExport void 
DDS_OctetsPluginSupport_destroy_data(
    DDS_Octets * sample);

extern DDSCDllExport RTIBool 
DDS_OctetsPluginSupport_copy_data(
    DDS_Octets * dst,
    const DDS_Octets * src);

extern DDSCDllExport void  
DDS_OctetsPluginSupport_print_data(
    const DDS_Octets * sample,
    const char * desc,
    unsigned int indent_level);

extern DDSCDllExport RTIBool 
DDS_Octets_initialize_ex(
    DDS_Octets * sample, RTIBool allocatePointers,RTIBool allocateMemory);

extern DDSCDllExport RTIBool 
DDS_Octets_initialize(
    DDS_Octets * sample);

extern DDSCDllExport RTIBool 
DDS_Octets_initialize_w_size_ex(
    DDS_Octets * sample, int size, RTIBool allocatePointers);

extern DDSCDllExport RTIBool 
DDS_Octets_initialize_w_size(
    DDS_Octets * sample, int size);

extern DDSCDllExport void 
DDS_Octets_finalize_ex(
    DDS_Octets * sample,RTIBool deletePointers);

extern DDSCDllExport void 
DDS_Octets_finalize(
    DDS_Octets * sample);

extern DDSCDllExport RTIBool 
DDS_Octets_copy(
    DDS_Octets * dst,
    const DDS_Octets * src);

extern DDSCDllExport RTIBool
DDS_Octets_initialize_w_params(
    DDS_Octets* self,
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport void 
DDS_Octets_finalize_w_params(
    DDS_Octets* self,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport void 
DDS_OctetsPluginSupport_destroy_data_w_params(
    DDS_Octets* userData,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport struct DDS_Octets*
DDS_OctetsPluginSupport_create_data_w_params(
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport RTIBool
DDS_OctetsPlugin_serialize_to_cdr_buffer(
    char * buffer,
    unsigned int * length,
    const DDS_Octets *sample);

extern DDSCDllExport
RTIBool DDS_OctetsPlugin_serialize_to_cdr_buffer_ex(
        char *buffer,
        unsigned int *length,
        const DDS_Octets *sample,
        DDS_DataRepresentationId_t representation);

extern DDSCDllExport RTIBool
DDS_OctetsPlugin_deserialize_from_cdr_buffer(
    DDS_Octets *sample,
    const char * buffer,
    unsigned int length);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_OctetsPlugin_data_to_string(
    const DDS_Octets *sample,
    char *str,
    DDS_UnsignedLong *str_size,
    const DDS_PrintFormatProperty *property);

extern DDSCDllExport
struct PRESTypePlugin *DDS_KeyedOctetsPlugin_new(void);

extern DDSCDllExport
void DDS_KeyedOctetsPlugin_delete(struct PRESTypePlugin *self);

extern DDSCDllExport DDS_KeyedOctets *
DDS_KeyedOctetsPluginSupport_create_data_ex(RTIBool allocate_pointers);

extern DDSCDllExport DDS_KeyedOctets *
DDS_KeyedOctetsPluginSupport_create_data(void);

extern DDSCDllExport DDS_KeyedOctets *
DDS_KeyedOctetsPluginSupport_create_data_w_size_ex(int key_size, int size, RTIBool allocate_pointers);

extern DDSCDllExport DDS_KeyedOctets *
DDS_KeyedOctetsPluginSupport_create_data_w_size(int key_size, int size);

extern DDSCDllExport void 
DDS_KeyedOctetsPluginSupport_destroy_data_ex(
    DDS_KeyedOctets *sample,RTIBool deallocate_pointers);

extern DDSCDllExport void 
DDS_KeyedOctetsPluginSupport_destroy_data(
    DDS_KeyedOctets *sample);

extern DDSCDllExport RTIBool 
DDS_KeyedOctetsPluginSupport_copy_data(
    DDS_KeyedOctets *dst,
    const struct DDS_KeyedOctets *src);

extern DDSCDllExport void  
DDS_KeyedOctetsPluginSupport_print_data(
    const DDS_KeyedOctets * sample,
    const char * desc,
    unsigned int indent_level);

extern DDSCDllExport RTIBool 
DDS_KeyedOctets_initialize_ex(
    DDS_KeyedOctets * sample,
    RTIBool allocatePointers,
    RTIBool allocateMemory);

extern DDSCDllExport RTIBool 
DDS_KeyedOctets_initialize(
    DDS_KeyedOctets * sample);

extern DDSCDllExport RTIBool 
DDS_KeyedOctets_initialize_w_size_ex(
    DDS_KeyedOctets * sample, int key_size, int size, RTIBool allocatePointers);

extern DDSCDllExport RTIBool 
DDS_KeyedOctets_initialize_w_size(
    DDS_KeyedOctets * sample, int key_size, int size);

extern DDSCDllExport void 
DDS_KeyedOctets_finalize_ex(
    DDS_KeyedOctets * sample,RTIBool deletePointers);

extern DDSCDllExport void 
DDS_KeyedOctets_finalize(
    DDS_KeyedOctets * sample);

extern DDSCDllExport
RTIBool DDS_KeyedOctets_copy(
    DDS_KeyedOctets * dst,
    const DDS_KeyedOctets * src);

extern DDSCDllExport RTIBool
DDS_KeyedOctets_initialize_w_params(
    DDS_KeyedOctets* self,
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport void 
DDS_KeyedOctets_finalize_w_params(
    DDS_KeyedOctets* self,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport void 
DDS_KeyedOctetsPluginSupport_destroy_data_w_params(
    DDS_KeyedOctets* userData,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport struct DDS_KeyedOctets*
DDS_KeyedOctetsPluginSupport_create_data_w_params(
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport RTIBool
DDS_KeyedOctetsPlugin_serialize_to_cdr_buffer(
    char * buffer,
    unsigned int * length,
    const DDS_KeyedOctets *sample);

extern DDSCDllExport
RTIBool DDS_KeyedOctetsPlugin_serialize_to_cdr_buffer_ex(
        char *buffer,
        unsigned int *length,
        const DDS_KeyedOctets *sample,
        DDS_DataRepresentationId_t representation);

extern DDSCDllExport RTIBool
DDS_KeyedOctetsPlugin_deserialize_from_cdr_buffer(
    DDS_KeyedOctets *sample,
    const char * buffer,
    unsigned int length);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_KeyedOctetsPlugin_data_to_string(
    const DDS_KeyedOctets *sample,
    char *str,
    DDS_UnsignedLong *str_size,
    const DDS_PrintFormatProperty *property);

extern DDSCDllExport
struct PRESTypePlugin *DDS_StringPlugin_new(void);

extern DDSCDllExport
void DDS_StringPlugin_delete(struct PRESTypePlugin *self);

extern DDSCDllExport char *
DDS_StringPluginSupport_create_data_ex(RTIBool allocate_pointers);

extern DDSCDllExport char *
DDS_StringPluginSupport_create_data(void);

extern DDSCDllExport char *
DDS_StringPluginSupport_create_data_w_size_ex(int size, RTIBool allocate_pointers);

extern DDSCDllExport char *
DDS_StringPluginSupport_create_data_w_size(int size);

extern DDSCDllExport void 
DDS_StringPluginSupport_destroy_data_ex(
    char *sample,RTIBool deallocate_pointers);

extern DDSCDllExport void 
DDS_StringPluginSupport_destroy_data(
    char *sample);

extern DDSCDllExport RTIBool 
DDS_StringPluginSupport_copy_data(
    char *dst,
    const char *src);

extern DDSCDllExport void  
DDS_StringPluginSupport_print_data(
    const char *sample,
    const char *desc,
    unsigned int indent_level);

extern DDSCDllExport RTIBool 
DDS_String_initialize_ex(
    char * sample,
    RTIBool allocatePointers,
    RTIBool allocateMemory);

extern DDSCDllExport RTIBool 
DDS_String_initialize(
    char * sample);

extern DDSCDllExport RTIBool 
DDS_String_initialize_w_size_ex(
    char * sample, int size, RTIBool allocatePointers);

extern DDSCDllExport RTIBool 
DDS_String_initialize_w_size(
        char * sample, int size);

extern DDSCDllExport void 
DDS_String_finalize_ex(
    char * sample,RTIBool deletePointers);

extern DDSCDllExport void 
DDS_String_finalize(
    char * sample);

extern DDSCDllExport RTIBool 
DDS_String_copy(
    char * dst,
    const  char * src);

extern DDSCDllExport RTIBool
DDS_String_initialize_w_params(
    char* self,
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport void 
DDS_String_finalize_w_params(
    char* self,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport void 
DDS_StringPluginSupport_destroy_data_w_params(
    char* userData,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport char*
DDS_StringPluginSupport_create_data_w_params(
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport RTIBool
DDS_StringPlugin_serialize_to_cdr_buffer(
    char * buffer,
    unsigned int * length,
    const char *sample);

extern DDSCDllExport
RTIBool DDS_StringPlugin_serialize_to_cdr_buffer_ex(
        char *buffer,
        unsigned int *length,
        const char *sample,
        DDS_DataRepresentationId_t representation);

extern DDSCDllExport RTIBool
DDS_StringPlugin_deserialize_from_cdr_buffer(
    char **sample,
    const char * buffer,
    unsigned int length);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_StringPlugin_data_to_string(
    const char *sample,
    char *str,
    DDS_UnsignedLong *str_size,
    const DDS_PrintFormatProperty *property);

extern DDSCDllExport
struct PRESTypePlugin *DDS_KeyedStringPlugin_new(void);

extern DDSCDllExport
void DDS_KeyedStringPlugin_delete(struct PRESTypePlugin *self);

extern DDSCDllExport DDS_KeyedString *
DDS_KeyedStringPluginSupport_create_data_ex(RTIBool allocate_pointers);

extern DDSCDllExport DDS_KeyedString *
DDS_KeyedStringPluginSupport_create_data(void);

extern DDSCDllExport DDS_KeyedString *
DDS_KeyedStringPluginSupport_create_data_w_size_ex(int key_size, int size, RTIBool allocate_pointers);

extern DDSCDllExport DDS_KeyedString *
DDS_KeyedStringPluginSupport_create_data_w_size(int key_size, int size);

extern DDSCDllExport void 
DDS_KeyedStringPluginSupport_destroy_data_ex(
    DDS_KeyedString *sample,RTIBool deallocate_pointers);

extern DDSCDllExport void 
DDS_KeyedStringPluginSupport_destroy_data(
    DDS_KeyedString *sample);

extern DDSCDllExport RTIBool 
DDS_KeyedStringPluginSupport_copy_data(
    DDS_KeyedString *dst,
    const struct DDS_KeyedString *src);

extern DDSCDllExport void  
DDS_KeyedStringPluginSupport_print_data(
    const DDS_KeyedString * sample,
    const char * desc,
    unsigned int indent_level);

extern DDSCDllExport RTIBool 
DDS_KeyedString_initialize_ex(
    DDS_KeyedString * sample,
    RTIBool allocatePointers,
    RTIBool allocateMemory);

extern DDSCDllExport RTIBool 
DDS_KeyedString_initialize(
    DDS_KeyedString * sample);

extern DDSCDllExport RTIBool 
DDS_KeyedString_initialize_w_size_ex(
    DDS_KeyedString * sample, int key_size, int size, RTIBool allocatePointers);

extern DDSCDllExport RTIBool 
DDS_KeyedString_initialize_w_size(
    DDS_KeyedString * sample, int key_size, int size);

extern DDSCDllExport void 
DDS_KeyedString_finalize_ex(
    DDS_KeyedString * sample,RTIBool deletePointers);

extern DDSCDllExport void 
DDS_KeyedString_finalize(
    DDS_KeyedString * sample);

extern DDSCDllExport
RTIBool DDS_KeyedString_copy(
    DDS_KeyedString * dst,
    const DDS_KeyedString * src);

extern DDSCDllExport RTIBool
DDS_KeyedString_initialize_w_params(
    DDS_KeyedString* self,
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport void 
DDS_KeyedString_finalize_w_params(
    DDS_KeyedString* self,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport void 
DDS_KeyedStringPluginSupport_destroy_data_w_params(
    DDS_KeyedString* userData,
    const struct DDS_TypeDeallocationParams_t * deallocParams);

extern DDSCDllExport struct DDS_KeyedString*
DDS_KeyedStringPluginSupport_create_data_w_params(
    const struct DDS_TypeAllocationParams_t * allocParams);

extern DDSCDllExport RTIBool
DDS_KeyedStringPlugin_serialize_to_cdr_buffer(
    char * buffer,
    unsigned int * length,
    const DDS_KeyedString *sample);

extern DDSCDllExport
RTIBool DDS_KeyedStringPlugin_serialize_to_cdr_buffer_ex(
        char *buffer,
        unsigned int *length,
        const DDS_KeyedString *sample,
        DDS_DataRepresentationId_t representation);

extern DDSCDllExport RTIBool
DDS_KeyedStringPlugin_deserialize_from_cdr_buffer(
    DDS_KeyedString *sample,
    const char * buffer,
    unsigned int length);

extern DDSCDllExport
DDS_ReturnCode_t DDS_KeyedStringPlugin_data_to_string(
    const DDS_KeyedString *sample,
    char *str,
    DDS_UnsignedLong *str_size,
    const DDS_PrintFormatProperty *property);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* dds_c_builtintypes_impl_h */
