/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_dynamicdata_impl.h    generated by: makeheader    Sat Mar  9 09:39:08 2024
 *
 *		built from:	dynamicdata_impl.ifc
 */

#ifndef dds_c_dynamicdata_impl_h
#define dds_c_dynamicdata_impl_h


  #ifndef dds_c_publication_h
    #include "dds_c/dds_c_publication.h"
  #endif
  #ifndef dds_c_dll_h
    #include "dds_c/dds_c_dll.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

extern DDSCDllVariable const char *DDS_DYNAMIC_DATA_PLUGIN_TYPE_NAME;


#define DDS_DYNAMIC_DATA_INITIAL_ALIGNMENT_42E_COMPATIBLE       4L


#define DDS_DYNAMIC_DATA_MINIMAL_BUFFER_SIZE 128

struct DDS_DynamicDataPluginSupport;

extern DDSCDllExport
struct PRESTypePlugin *DDS_DynamicDataTypePlugin_new(
    const char *type_name, /* is_keyed, is_untyped?, etc. .. */
    struct DDS_DynamicDataPluginSupport *support);

extern DDSCDllExport
void DDS_DynamicDataTypePlugin_delete(struct PRESTypePlugin *self);


/* Forward declarations */
struct DDS_DynamicDataTypeSupport;
struct DDS_DynamicData;

extern DDSCDllExport
void *DDS_DynamicDataTypeSupport_get_registration_data(
        const struct DDS_DynamicDataTypeSupport *self);

extern DDSCDllExport
struct PRESTypePlugin *DDS_DynamicDataTypePlugin_newI(
    const char *type_name,
    struct DDS_DynamicDataTypeSupport *support);

extern DDSCDllExport
const DDS_TypeCodeHandle * DDS_DynamicData2_assert_typecode(
        struct RTIXCdrInterpreterPrograms **programsOut,
        const DDS_TypeCode *originalTypeCode,
        DDS_Boolean generatePrograms,
        DDS_TypeCodeOptimizationLevel optimizationLevel);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DynamicData_one_based_indexing(
        struct DDS_DynamicData *self, 
        DDS_Boolean one_based_indexing);


struct DDS_DynamicDataSerializationData {
    DDS_Boolean transform_to_internal_representation;
};


#ifdef __cplusplus
    }
#endif

#endif /* dds_c_dynamicdata_impl_h */
