/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dl_driver_activation.h    generated by: makeheader    Sat Mar  9 09:37:23 2024
 *
 *		built from:	activation.ifc
 */

#ifndef dl_driver_activation_h
#define dl_driver_activation_h


#include "dl_driver/dl_driver_activation_user.h"


#define RTI_ACTIVATION_LIBRARY_NAME "rti_activation"


typedef int (*DLDRIVERActivation_InitializeFunction)(
        void **userData,
        char errorContactInfo[RTI_ACTIVATION_LIBRARY_CONTACT_INFO_MESSAGE_MAX_SIZE],
        struct RTI_ActivationLibraryException *exception);


typedef int (*DLDRIVERActivation_FinalizeFunction)(
        void **userData,
        struct RTI_ActivationLibraryException *exception);


typedef int (*DLDRIVERActivation_GetActivationStringFunction)(
        char *buffer,
        unsigned int *size,
        void **userData,
        struct RTI_ActivationLibraryException *exception);


struct DLDRIVERActivationPlugin {
    void * _libHandle;
    DLDRIVERActivation_GetActivationStringFunction getActivationStringFunction;
    DLDRIVERActivation_InitializeFunction initializeFunction;
    DLDRIVERActivation_FinalizeFunction finalizeFunction;
};


#define DLDRIVERActivationPlugin_INITIALIZER \
    { \
        NULL, /* libraryHandle */ \
        NULL, /* DLDRIVERActivation_GetActivationStringFunction */ \
        NULL, /* DLDRIVERActivation_InitializeFunction */ \
        NULL, /* DLDRIVERActivation_FinalizeFunction */ \
    }

extern DLDRIVERDllExport
RTIBool DLDRIVERActivation_loadPlugin(
        struct DLDRIVERActivationPlugin *self,
        const char *libName);

extern DLDRIVERDllExport
RTIBool DLDRIVERActivation_unloadPlugin(struct DLDRIVERActivationPlugin *self);

#endif /* dl_driver_activation_h */
