/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dl_driver_log.h    generated by: makeheader    Sat Mar  9 09:37:22 2024
 *
 *		built from:	log.ifc
 */

#ifndef dl_driver_log_h
#define dl_driver_log_h


  #ifndef dl_driver_dll_h
    #include "dl_driver/dl_driver_dll.h"
  #endif
  #ifndef log_common_h
    #include "log/log_common.h"
  #endif
  #ifdef __cplusplus
      extern "C" {
  #endif


  /*e \ingroup DLDRIVERLogModule
    Submodule ID for DLDRIVER.
  */
  #define SUBMODULE_DLDRIVER (0x1000)
  /*e \ingroup DLDRIVERLogModule
    Submodule ID for ODBC DLDRIVER.
  */
  #define SUBMODULE_DLDRIVER_ODBC (0x2000)
  
  /*e \ingroup DLDRIVERLogModule
    Submodule ID for ODBCSETUP DLDRIVER.
  */
  #define SUBMODULE_DLDRIVER_ODBCSETUP (0x3000)

  /*e \ingroup DLDRIVERLogModule
    Submodule ID for ACTIVATION DLDRIVER.
  */
  #define SUBMODULE_DLDRIVER_ACTIVATION (0x4000)



  /*e \ingroup DLDRIVERLogModule
    Mask for turning on logging for only the ODBC submodule
  */
  #define DLDRIVER_SUBMODULE_MASK_ODBC (0x0002)
  /*e \ingroup DLDRIVERLogModule
    Mask for turning on logging for only the ACTIVATION submodule
  */
  #define DLDRIVER_SUBMODULE_MASK_ACTIVATION (0x0004)
  /*e \ingroup DLDRIVERLogModule
    Mask for turning on logging for all submoudles
  */
  #define DLDRIVER_SUBMODULE_MASK_ALL RTI_LOG_SUBMODULE_MASK_ALL

extern DLDRIVERDllExport
void DLDRIVERLog_setDependencyInstrumentationMask(RTILogBitmap verbosity);


  #ifdef __cplusplus
    }	/* extern "C" */
  #endif

#endif /* dl_driver_log_h */
