/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_errorCode.h    generated by: makeheader    Sat Mar  9 09:37:07 2024
 *
 *		built from:	errorCode.ifc
 */

#ifndef osapi_errorCode_h
#define osapi_errorCode_h


  #ifdef __cplusplus
    extern "C" {
  #endif

typedef enum {
    /*e \brief The operation succeeded.
     */
    RTI_OSAPI_ERROR_CODE_OK = 0,
    /*e \brief The lock could not be acquired before the specified timeout expired.
     */
    RTI_OSAPI_ERROR_CODE_ETIMEDOUT = 1,
    /*e \brief The system lacked the necessary resources (other than memory) to
     * initialize another lock.
     */
    RTI_OSAPI_ERROR_CODE_EAGAIN = 2,
    /*e \brief The value specified is not valid.
     */
    RTI_OSAPI_ERROR_CODE_EINVAL = 3,
    /*e \brief Insufficient memory exists to initialize the lock.
     */
    RTI_OSAPI_ERROR_CODE_ENOMEM = 4,
    /*e \brief The caller does not have the privilege to perform the operation.
     */
    RTI_OSAPI_ERROR_CODE_EPERM = 5,
    /*e \brief An attempt was made to destroy the lock  while it is locked or
     * referenced as part of a wait on a condition variable.
     */
    RTI_OSAPI_ERROR_CODE_EBUSY = 6,
    /*e \brief The current thread already owns the lock.
     */
    RTI_OSAPI_ERROR_CODE_EDEADLK = 7,
    /*e \brief A fault occurred when the kernel tried to access the resource.
     */
    RTI_OSAPI_ERROR_CODE_EFAULT = 8,
    /*e \brief Generic error.
     */
    RTI_OSAPI_ERROR_CODE_ERROR = 9
} RTIOsapiConcurrencyErrorCode;


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* osapi_errorCode_h */
