/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_file.h    generated by: makeheader    Sat Mar  9 09:37:08 2024
 *
 *		built from:	file.ifc
 */

#ifndef osapi_file_h
#define osapi_file_h


#include <errno.h>
#include "osapi/osapi_type.h"
#include "osapi/osapi_dll.h"
#include "osapi/osapi_vxVersions.h"
#include "osapi/osapi_ntptime.h"
#include <stdio.h>
#include <stdarg.h>

#ifdef __cplusplus
extern "C" {
#endif


extern RTIOsapiDllExport int RTIOsapiFile_close(FILE *f);

extern RTIOsapiDllExport FILE *RTIOsapiFile_open(
        const char *fileName,
        const char *mode);

extern RTIOsapiDllExport int RTIOsapiFile_getc(FILE *f);

extern RTIOsapiDllExport int RTIOsapiFile_putc(FILE *f, int res);

extern RTIOsapiDllExport
RTIBool RTIOsapiFile_copy(const char *dstFileName, const char *srcFileName);

extern RTIOsapiDllExport
RTIBool RTIOsapiFile_equals(const char *fileX, const char *fileY);

extern RTIOsapiDllExport RTIBool RTIOsapiFile_exists(const char *fileName);

extern RTIOsapiDllExport RTIBool RTIOsapiFile_remove(const char *fileName);

extern RTIOsapiDllExport
RTIBool RTIOsapiFile_searchString(FILE *f, const char *str);


#if defined(RTI_LINUX) || defined(RTI_DARWIN) || defined(RTI_AIX) \
        || defined(RTI_WIN32)
  #define RTI_SUPPORT_HIGH_RESOLUTION_FILE_TIMESTAMPS
#endif

extern RTIOsapiDllExport RTIBool RTIOsapiFile_getTimestamps(
        const char *fileName,
        struct RTINtpTime *accessTs,
        struct RTINtpTime *modificationTs,
        struct RTINtpTime *statusChangeTs);


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* osapi_file_h */
