/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_library.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	library.ifc
 */

#ifndef osapi_library_h
#define osapi_library_h



#ifndef osapi_type_h
  #include "osapi/osapi_type.h"
#endif
#ifndef osapi_dll_h
  #include "osapi/osapi_dll.h"
#endif

#if (defined(RTI_LINUX) || defined(RTI_SOL2) || defined(RTI_AIX) \
    || defined(RTI_DARWIN))
  #include <dlfcn.h>
#endif

#if (defined(RTI_LINUX) || defined(RTI_SOL2) || defined(RTI_AIX) \
    || defined(RTI_DARWIN))
  /* RTLD_LAZY and RTLD_NOW are already defined */
#else
  #define RTLD_LAZY   1
  #define RTLD_NOW    2
#endif

#ifndef RTI_UNIX_DL
  #if (defined(RTI_LINUX) || defined(RTI_SOL2) || defined(RTI_AIX) \
      || defined(RTI_DARWIN) || defined(RTI_QNX) || defined(RTI_VXWORKS_DL)) \
      && (ENABLE_FACE_COMPLIANCE == FACE_COMPLIANCE_LEVEL_NONE)
    #define RTI_UNIX_DL

    #if defined(RTI_DARWIN)
        #define RTI_DYLIB_FILE_EXTENSION     ".dylib"
    #else
        #define RTI_DYLIB_FILE_EXTENSION     ".so"
    #endif
  #endif
#endif

/*e \ingroup RTIOsapiLibraryClass
    \brief Whith this mode, the references to the library symbols are
    resolved when the code that references them is executed.
*/
#define RTI_OSAPI_LIBRARY_RTLD_LAZY RTLD_LAZY
/*e \ingroup RTIOsapiLibraryClass
    \brief Whith this mode, all the undefined symbols in the library 
    are resolved before RTIOsapiLibrary_open returns.
*/
#define RTI_OSAPI_LIBRARY_RTLD_NOW RTLD_NOW

/*i \ingroup RTIOsapiLibraryClass
    \brief Defines the architectures that support loading dynamic libraries.
*/
#ifndef RTI_OSAPI_DYNAMIC_LIBRARY_LOADING_SUPPORT
  #if defined(RTI_UNIX_DL) || defined(RTI_WIN32) || defined(RTI_INTIME)
    #define RTI_OSAPI_DYNAMIC_LIBRARY_LOADING_SUPPORT
  #endif
#endif

#ifdef __cplusplus
    extern "C" {
#endif


extern RTIOsapiDllExport RTIBool
RTIOsapiLibrary_getFullSharedLibraryName(
        char* fileName,
        const char* libraryName,
        RTIBool autoAppendDebugModifier);

extern RTIOsapiDllExport void *
RTIOsapiLibrary_open(const char *libraryName, int mode);

extern RTIOsapiDllExport void *
RTIOsapiLibrary_openNoDebugModifier(const char *libraryName, int mode);

extern RTIOsapiDllExport void *
RTIOsapiLibrary_openEx(
        const char *libraryName,
        int mode,
        RTIBool autoAppendDebugModifier,
        RTIBool logError);

extern RTIOsapiDllExport int
RTIOsapiLibrary_close(void * handle);

extern RTIOsapiDllExport void *
RTIOsapiLibrary_getSymbolAddress(void * handle,const char * symbol);

extern RTIOsapiDllExport
RTIBool RTIOsapiLibrary_isSharedLibrary(void);

extern RTIOsapiDllExport
RTIBool RTIOsapiLibrary_isDynamicLibraryLoadingSupported(void);


#ifdef __cplusplus
    }	/* extern "C" */
#endif


#endif /* osapi_library_h */
