/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_vxVersions.h    generated by: makeheader    Sat Mar  9 09:37:10 2024
 *
 *		built from:	vxVersions.ifc
 */

#ifndef osapi_vxVersions_h
#define osapi_vxVersions_h


#ifdef __cplusplus
    extern "C" {
#endif


#ifdef RTI_VXWORKS

#include "version.h"

#ifndef VXWORKS_MAJOR_VERSION
    #ifdef _WRS_VXWORKS_MAJOR
        #define VXWORKS_MAJOR_VERSION _WRS_VXWORKS_MAJOR
    #else
        #error "We are missing the VxWorks major version definition."
    #endif
#endif

#ifndef VXWORKS_MINOR_VERSION
    #ifdef _WRS_VXWORKS_MINOR
        #define VXWORKS_MINOR_VERSION _WRS_VXWORKS_MINOR
    #else
        #define VXWORKS_MINOR_VERSION 0
    #endif
#endif

#define VXWORKS_VERSION_5_0_OR_BETTER  (VXWORKS_MAJOR_VERSION >= 5)

#define VXWORKS_VERSION_5_1_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 5) && (VXWORKS_MINOR_VERSION >= 1))  || \
     (VXWORKS_MAJOR_VERSION > 5) \
  )

#define VXWORKS_VERSION_5_3_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 5) && (VXWORKS_MINOR_VERSION >= 3))  || \
     (VXWORKS_MAJOR_VERSION > 5) \
  )

#define VXWORKS_VERSION_5_4_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 5) && (VXWORKS_MINOR_VERSION >= 4))  || \
     (VXWORKS_MAJOR_VERSION > 5) \
  )

#define VXWORKS_VERSION_6_0_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 6) && (VXWORKS_MINOR_VERSION >= 0))  || \
     (VXWORKS_MAJOR_VERSION > 6) \
  )

#define VXWORKS_VERSION_6_3_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 6) && (VXWORKS_MINOR_VERSION >= 3))  || \
     (VXWORKS_MAJOR_VERSION > 6) \
  )

#define VXWORKS_VERSION_6_5_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 6) && (VXWORKS_MINOR_VERSION >= 5))  || \
     (VXWORKS_MAJOR_VERSION > 6) \
  )

#define VXWORKS_VERSION_6_6_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 6) && (VXWORKS_MINOR_VERSION >= 6))  || \
     (VXWORKS_MAJOR_VERSION > 6) \
  )

#define VXWORKS_VERSION_6_7_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 6) && (VXWORKS_MINOR_VERSION >= 7))  || \
     (VXWORKS_MAJOR_VERSION > 6) \
  )

#define VXWORKS_VERSION_6_8_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 6) && (VXWORKS_MINOR_VERSION >= 8)) || \
     (VXWORKS_MAJOR_VERSION > 6) \
  )

#define VXWORKS_VERSION_7_0_OR_BETTER \
  (  ((VXWORKS_MAJOR_VERSION == 7) && (VXWORKS_MINOR_VERSION >= 0)) || \
     (VXWORKS_MAJOR_VERSION > 7) \
  )

#if VXWORKS_VERSION_6_6_OR_BETTER && defined(RTI_SMP_SUPPORT)
  #define VXWORKS_SMP_SUPPORT 1
#else
  #define VXWORKS_NO_SMP_SUPPORT 1
#endif

/* smp support for version 6.8 or better */
#if VXWORKS_VERSION_6_8_OR_BETTER
  #if defined(VXWORKS_NO_SMP_SUPPORT)
    #undef VXWORKS_NO_SMP_SUPPORT
  #endif
  #define VXWORKS_SMP_SUPPORT 1
#endif

#define VXWORKS_AE_VERSION_1_0_OR_BETTER  (VXWORKS_MAJOR_VERSION >= 175)

#endif /* RTI_VXWORKS */


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* osapi_vxVersions_h */
