/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_inlineQos.h    generated by: makeheader    Sat Mar  9 09:38:35 2024
 *
 *		built from:	inlineQos.ifc
 */

#ifndef pres_inlineQos_h
#define pres_inlineQos_h


#ifndef osapi_type_h
    #include "osapi/osapi_type.h"
#endif
#ifndef pres_common_h
    #include "pres/pres_common.h"
#endif
#ifndef pres_psService_h
    #include "pres/pres_psService.h"
#endif

#ifdef __cplusplus
    extern "C" {
#endif


#define PRES_INLINE_QOS_IMMUTABLE_FILTER_SIGNATURE_SIZE 16 
    /* sizeof(struct PRESInlineParameterHeader) + sizeof(signatureBitmapLength)
     +  sizeof(signatureBitmap) + sizeof(signatureLength) */

struct PRESInlineParameterHeader {
    RTI_UINT16  pid;
    RTI_UINT16  paramLength;
};

struct PRESProtocolInlineQos {
    /* original data writer */
    struct PRESInlineParameterHeader originalWriterHeader;
    struct MIGRtpsGuid originalWriterGuid;
    struct REDASequenceNumber originalWriterSequenceNumber;
    /* coherent set */
    struct PRESInlineParameterHeader coherency_header;
    struct REDASequenceNumber coherentSetFirstSn;
    struct PRESInlineParameterHeader groupCoherentSetFirstSnHeader;
    struct REDASequenceNumber groupCoherentSetFirstSn;
    struct PRESInlineParameterHeader coherentSetSampleCountHeader;
    RTI_INT32 coherentSetSampleCount;
    /* keyHash */
    struct PRESInlineParameterHeader keyHash_header;
    RTICdrOctet keyHash[MIG_RTPS_KEY_HASH_MAX_LENGTH];
    /* filter signature */
    struct PRESInlineParameterHeader  signature_pid;
    RTI_INT32    signatureBitmapLength;
    RTI_INT32    signatureBitmap[PRES_FILTER_SIGNATURE_BITMAP_LENGTH];
    RTI_INT32    signatureLength;
    struct PRESContentFilterSignature signature[PRES_FILTER_SIGNATURE_LENGTH_MAX];
    /* related original data writer */
    struct PRESInlineParameterHeader relatedOriginalWriterHeader;
    struct MIGRtpsGuid relatedOriginalWriterGuid;
    struct REDASequenceNumber relatedOriginalWriterSequenceNumber;
    struct PRESInlineParameterHeader sourceGuidHeader;
    struct MIGRtpsGuid sourceGuid;
    struct PRESInlineParameterHeader relatedSourceGuidHeader;
    struct MIGRtpsGuid relatedSourceGuid;
    struct PRESInlineParameterHeader relatedReaderGuidHeader;
    struct MIGRtpsGuid relatedReaderGuid;
    struct PRESInlineParameterHeader topicQueryGuidHeader;
    struct MIGRtpsGuid topicQueryGuid;
    struct PRESInlineParameterHeader sampleSignatureHeader;
    struct PRESSampleSignature sampleSignature;
    struct REDASequenceNumber relatedEpoch;
};

struct PRESInlineQosBuffer {
    struct PRESProtocolInlineQos protocolParams;
    struct PRESInlineParameterHeader sentinel;
};


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* pres_inlineQos_h */
