/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_topicQuery.h    generated by: makeheader    Sat Mar  9 09:38:37 2024
 *
 *		built from:	topicQuery.ifc
 */

#ifndef pres_topicQuery_h
#define pres_topicQuery_h


 #ifndef pres_dll_h
    #include "pres/pres_dll.h"
 #endif
 #ifndef pres_common_h
    #include "pres/pres_common.h"
 #endif
 #ifndef pres_psService_h
    #include "pres/pres_psService.h"
 #endif
 #ifndef reda_worker_h
    #include "reda/reda_worker.h"
 #endif

#ifdef __cplusplus
    extern "C" {
#endif


 
struct PRESTopicQuery;

extern PRESDllExport
void PRESTopicQuerySelection_finalize(
    struct PRESTopicQuerySelection * self);

extern PRESDllExport
void PRESTopicQuerySelection_initialize(
    struct PRESTopicQuerySelection * self);

extern PRESDllExport struct PRESTopicQuery *
    PRESPsReader_createTopicQuery(
        struct PRESPsReader * me,
        const struct PRESOctetGuid * queryGuid,
        const struct PRESTopicQuerySelection * selection,
        struct REDAWorker* worker);

extern PRESDllExport
RTIBool PRESPsReader_deleteTopicQuery(
    struct PRESPsReader *me,
    int *failReason,
    struct PRESTopicQuery * query,
    struct REDAWorker* worker);

extern PRESDllExport
RTIBool PRESPsReader_destroyAllTopicQueries(
    struct PRESPsReader *me,
    int *failReason,
    struct REDAWorker *worker);

extern PRESDllExport
RTIBool PRESTopicQuery_enable(
           struct PRESTopicQuery * self,
           struct REDAWorker* worker);

extern PRESDllExport
void * PRESTopicQuery_getUserObject(
           struct PRESTopicQuery * self);

extern PRESDllExport
void PRESTopicQuery_setUserObject(
         struct PRESTopicQuery * self,
         void * userObject);

extern PRESDllExport
const struct PRESOctetGuid * PRESTopicQuery_getGuid(
    struct PRESTopicQuery * self);

extern PRESDllExport
const struct PRESTopicQuerySelection * PRESTopicQuery_getSelection(
    struct PRESTopicQuery * self);

extern PRESDllExport
struct PRESTopicQuery * PRESPsReader_getFirstTopicQuery(
    struct PRESPsReader * me,
    struct REDAWorker* worker);

extern PRESDllExport
struct PRESTopicQuery * PRESPsReader_getNextTopicQuery(
    struct PRESPsReader * me,
    struct PRESTopicQuery * query,
    struct REDAWorker* worker);

extern PRESDllExport
struct PRESTopicQuery* PRESPsReader_lookupTopicQueryByGuid(
    struct PRESPsReader *me, 
    const struct PRESOctetGuid * queryGuid,
    struct REDAWorker *worker);

extern PRESDllExport
int PRESPsReader_getTopicQueryCount(
    struct PRESPsReader *me,
    struct REDAWorker *worker);

 
struct PRESTopicQueryDispatchInfo {
    struct PRESTopicQuerySelection selection;
    struct MIGRtpsGuid topicQueryGuid;
    struct MIGRtpsGuid relatedReaderGuid;
    struct PRESInstanceHandle topicQueryInstanceHandle;
    RTI_INT64 topicQueryChangeEpoch;
};


#define PRES_TOPIC_QUERY_DISPATCH_INFO_DEFAULT {\
    PRES_TOPIC_QUERY_SELECTION_DEFAULT, \
    MIG_RTPS_GUID_UNKNOWN, \
    MIG_RTPS_GUID_UNKNOWN, \
    PRESInstanceHandle_INITIALIZER,\
    PRES_PS_SUBSCRIPTION_PARAMETER_CHANGE_EPOCH_UNKNOWN}


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* pres_topicQuery_h */
