/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)property_propertyValidation.h    generated by: makeheader    Sat Mar  9 09:37:36 2024
 *
 *		built from:	propertyValidation.ifc
 */

#ifndef property_propertyValidation_h
#define property_propertyValidation_h



#ifndef property_dll_h
  #include "property/property_dll.h"
#endif
#ifndef osapi_type_h
  #include "osapi/osapi_type.h"
#endif

#ifdef __cplusplus
    extern "C" {
#endif



struct PROPERTYPluginProperty {
    const char *name; /* Plugin name. */
    const char *prefix; /* Prefix plugin */
    const char *createFunction; /* CreateFunction plugin */
    const char **privateProperties;  /* List of private property names */
    int privatePropertiesSize; /* Size of of private property names list */
    const char **publicProperties; /* List of public property names */
    int publicPropertiesSize; /* Size of of public property names list */
};



/********************************* DATAREADER *********************************/
#define PROPERTY_VALID_PRIVATE_PROPERTIES_SIZE_DATAREADER 29
extern PROPERTYDllVariable const char *PROPERTY_VALID_PRIVATE_PROPERTIES_DATAREADER[];

#define PROPERTY_VALID_PROPERTY_PREFIXES_SIZE_DATAREADER 2
extern PROPERTYDllVariable const char *PROPERTY_VALID_PROPERTY_PREFIXES_DATAREADER[];

#define PROPERTY_VALID_PUBLIC_PROPERTIES_SIZE_DATAREADER 34
extern PROPERTYDllVariable const char *PROPERTY_VALID_PUBLIC_PROPERTIES_DATAREADER[];


/********************************* DATAWRITER *********************************/
#define PROPERTY_VALID_PRIVATE_PROPERTIES_SIZE_DATAWRITER 50
extern PROPERTYDllVariable const char *PROPERTY_VALID_PRIVATE_PROPERTIES_DATAWRITER[];

#define PROPERTY_VALID_PROPERTY_PREFIXES_SIZE_DATAWRITER 2
extern PROPERTYDllVariable const char *PROPERTY_VALID_PROPERTY_PREFIXES_DATAWRITER[];

#define PROPERTY_VALID_PUBLIC_PROPERTIES_SIZE_DATAWRITER 35
extern PROPERTYDllVariable const char *PROPERTY_VALID_PUBLIC_PROPERTIES_DATAWRITER[];


/***************************** DOMAINPARTICIPANT *****************************/
#define PROPERTY_VALID_PRIVATE_PROPERTIES_SIZE_DOMAINPARTICIPANT 69
extern PROPERTYDllVariable const char *PROPERTY_VALID_PRIVATE_PROPERTIES_DOMAINPARTICIPANT[];

#define PROPERTY_VALID_PROPERTY_PREFIXES_SIZE_DOMAINPARTICIPANT 4
extern PROPERTYDllVariable const char *PROPERTY_VALID_PROPERTY_PREFIXES_DOMAINPARTICIPANT[];

#define PROPERTY_VALID_PUBLIC_PROPERTIES_SIZE_DOMAINPARTICIPANT 117
extern PROPERTYDllVariable const char *PROPERTY_VALID_PUBLIC_PROPERTIES_DOMAINPARTICIPANT[];


/****************************** FLOW_CONTROLLER ******************************/
#define PROPERTY_PLUGIN_NAME_FLOW_CONTROLLER "FLOW_CONTROLLER"
#define PROPERTY_PLUGIN_PREFIX_FLOW_CONTROLLER PROPERTY_PREFIX_DDS_FLOW_CONTROLLER_TOKEN_BUCKET_FLOW_CONTROLLER_NAME
#define PROPERTY_PLUGIN_CREATE_FUNCTION_FLOW_CONTROLLER ""
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_FLOW_CONTROLLER 0
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_FLOW_CONTROLLER[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_FLOW_CONTROLLER 7
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_FLOW_CONTROLLER[];


/********************************** LBEDISC **********************************/
#define PROPERTY_PLUGIN_NAME_LBEDISC "LBEDISC"
#define PROPERTY_PLUGIN_PREFIX_LBEDISC PROPERTY_PREFIX_DDS_DISCOVERY_ENDPOINT_LBEDISCOVERY
#define PROPERTY_PLUGIN_CREATE_FUNCTION_LBEDISC "DDS_LBEDiscoveryPlugin_create"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_LBEDISC 3
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_LBEDISC[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_LBEDISC 5
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_LBEDISC[];


/********************************** LBPDISC **********************************/
#define PROPERTY_PLUGIN_NAME_LBPDISC "LBPDISC"
#define PROPERTY_PLUGIN_PREFIX_LBPDISC PROPERTY_PREFIX_DDS_DISCOVERY_PARTICIPANT_LBPDISCOVERY
#define PROPERTY_PLUGIN_CREATE_FUNCTION_LBPDISC "DDS_LBPDiscoveryPlugin_create"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_LBPDISC 1
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_LBPDISC[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_LBPDISC 5
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_LBPDISC[];


/*********************************** LBRTPS ***********************************/
#define PROPERTY_PLUGIN_NAME_LBRTPS "LBRTPS"
#define PROPERTY_PLUGIN_PREFIX_LBRTPS PROPERTY_PREFIX_DDS_TRANSPORT_LBRTPS
#define PROPERTY_PLUGIN_CREATE_FUNCTION_LBRTPS "LBRTPS_Transport_create_plugin"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_LBRTPS 5
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_LBRTPS[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_LBRTPS 13
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_LBRTPS[];


/************************************ LBST ************************************/
#define PROPERTY_PLUGIN_NAME_LBST "LBST"
#define PROPERTY_PLUGIN_PREFIX_LBST PROPERTY_PREFIX_DDS_TRANSPORT_LBST
#define PROPERTY_PLUGIN_CREATE_FUNCTION_LBST "LBS_Transport_create_plugin"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_LBST 14
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_LBST[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_LBST 0
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_LBST[];


/********************************** SECURITY **********************************/
#define PROPERTY_PLUGIN_NAME_SECURITY "SECURITY"
#define PROPERTY_PLUGIN_PREFIX_SECURITY PROPERTY_PREFIX_COM_RTI_SERV_SECURE
#define PROPERTY_PLUGIN_CREATE_FUNCTION_SECURITY "RTI_Security_PluginSuite_create"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_SECURITY 39
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SECURITY[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_SECURITY 42
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SECURITY[];


/*********************************** SHMEM ***********************************/
#define PROPERTY_PLUGIN_NAME_SHMEM "SHMEM"
#define PROPERTY_PLUGIN_PREFIX_SHMEM PROPERTY_PREFIX_DDS_TRANSPORT_SHMEM_BUILTIN
#define PROPERTY_PLUGIN_CREATE_FUNCTION_SHMEM ""
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_SHMEM 13
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SHMEM[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_SHMEM 13
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SHMEM[];


/*********************************** TCPV4 ***********************************/
#define PROPERTY_PLUGIN_NAME_TCPV4 "TCPV4"
#define PROPERTY_PLUGIN_PREFIX_TCPV4 PROPERTY_PREFIX_DDS_TRANSPORT_TCPV4_TCP1
#define PROPERTY_PLUGIN_CREATE_FUNCTION_TCPV4 "NDDS_Transport_TCPv4_create"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_TCPV4 23
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_TCPV4[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_TCPV4 87
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_TCPV4[];


/*********************************** UDPV4 ***********************************/
#define PROPERTY_PLUGIN_NAME_UDPV4 "UDPV4"
#define PROPERTY_PLUGIN_PREFIX_UDPV4 PROPERTY_PREFIX_DDS_TRANSPORT_UDPV4_BUILTIN
#define PROPERTY_PLUGIN_CREATE_FUNCTION_UDPV4 ""
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_UDPV4 11
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_UDPV4[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_UDPV4 35
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_UDPV4[];


/********************************* UDPV4_WAN *********************************/
#define PROPERTY_PLUGIN_NAME_UDPV4_WAN "UDPV4_WAN"
#define PROPERTY_PLUGIN_PREFIX_UDPV4_WAN PROPERTY_PREFIX_DDS_TRANSPORT_UDPV4_WAN_BUILTIN
#define PROPERTY_PLUGIN_CREATE_FUNCTION_UDPV4_WAN ""
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_UDPV4_WAN 11
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_UDPV4_WAN[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_UDPV4_WAN 30
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_UDPV4_WAN[];


/*********************************** UDPV6 ***********************************/
#define PROPERTY_PLUGIN_NAME_UDPV6 "UDPV6"
#define PROPERTY_PLUGIN_PREFIX_UDPV6 PROPERTY_PREFIX_DDS_TRANSPORT_UDPV6_BUILTIN
#define PROPERTY_PLUGIN_CREATE_FUNCTION_UDPV6 ""
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_UDPV6 13
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_UDPV6[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_UDPV6 34
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_UDPV6[];


/******************************* WRITER_HISTORY *******************************/
#define PROPERTY_PLUGIN_NAME_WRITER_HISTORY "WRITER_HISTORY"
#define PROPERTY_PLUGIN_PREFIX_WRITER_HISTORY PROPERTY_PREFIX_DDS_DATA_WRITER_HISTORY_ODBC_PLUGIN_BUILTIN
#define PROPERTY_PLUGIN_CREATE_FUNCTION_WRITER_HISTORY ""
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_WRITER_HISTORY 10
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_WRITER_HISTORY[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_WRITER_HISTORY 11
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_WRITER_HISTORY[];


/*********************************** ZRTPS ***********************************/
#define PROPERTY_PLUGIN_NAME_ZRTPS "ZRTPS"
#define PROPERTY_PLUGIN_PREFIX_ZRTPS PROPERTY_PREFIX_DDS_TRANSPORT_ZRTPS
#define PROPERTY_PLUGIN_CREATE_FUNCTION_ZRTPS "ZRTPS_Transport_create_plugin"
#define PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_SIZE_ZRTPS 4
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PRIVATE_PROPERTIES_ZRTPS[];

#define PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_SIZE_ZRTPS 17
extern PROPERTYDllVariable const char *PROPERTY_PLUGIN_VALID_PUBLIC_PROPERTIES_ZRTPS[];


/********************** PROPERTY_VALID_PLUGIN_PROPERTIES **********************/
#define PROPERTY_VALID_PLUGIN_PROPERTIES_SIZE 13
extern PROPERTYDllVariable const struct PROPERTYPluginProperty PROPERTY_VALID_PLUGIN_PROPERTIES[];


/************************** LIST OF VALUE ATTRIBUTES **************************/

typedef enum {
    PROPERTY_VALUE_MUTABILITY_MUTABLE,
    PROPERTY_VALUE_MUTABILITY_MUTABLE_UNTIL_ENABLE,
    PROPERTY_VALUE_MUTABILITY_IMMUTABLE,
} PROPERTYValueMutability;



struct PROPERTYValueAttributes {
    const char *propertyName; /* Suffix only if plugin property. */
    const PROPERTYValueMutability mutability;
};



struct PROPERTYPluginValueAttributes {
    const char *prefix;
    const char *name;
    const char *createFunction;
    const struct PROPERTYValueAttributes *properties;
    int propertiesSize;
};


#define PROPERTY_NO_PLUGIN_VALUE_ATTRIBUTES_SIZE 43
extern PROPERTYDllVariable
const struct PROPERTYValueAttributes PROPERTY_NO_PLUGIN_VALUE_ATTRIBUTES[];

#define PROPERTY_PLUGIN_VALUE_ATTRIBUTES_SIZE 3
extern PROPERTYDllVariable
const struct PROPERTYPluginValueAttributes PROPERTY_PLUGIN_VALUE_ATTRIBUTES[];

#define PROPERTY_LOAD_PLUGINS_ARRAY_SIZE 4
extern PROPERTYDllVariable
const char *PROPERTY_LOAD_PLUGINS_ARRAY[];


#ifdef __cplusplus
    }   /* extern "C" */
#endif



#endif /* property_propertyValidation_h */
