/* $Id$

 (c) Copyright, Real-Time Innovations, 2014-2016.
 All rights reserved.
 No duplications, whole or partial, manual or electronic, may be made
 without express written permission.  Any such copies, or
 revisions thereof, must display this notice unaltered.
 This code contains trade secrets of Real-Time Innovations, Inc.
    
Description
-----------
File that contains all the configuration for expat, including prefixes for
avoiding symbol conflicts with other expat versions.


modification history
------------ -------
5.1.0, jpm Created
===============================================================================*/
#ifndef __EXPAT_CONFIG_H__
#define __EXPAT_CONFIG_H__

/* Create a RTI namespace for Expat Parser (see CORE-6043) */
#ifdef EXPAT_USE_RTI_NAMESPACE

#define addBinding RTI_addBinding
#define appendAttributeValue RTI_appendAttributeValue
#define ascii_encoding RTI_ascii_encoding
#define ascii_encoding_ns RTI_ascii_encoding_ns
#define ascii_toUtf8 RTI_ascii_toUtf8
#define attlist0 RTI_attlist0
#define attlist1 RTI_attlist1
#define attlist2 RTI_attlist2
#define attlist3 RTI_attlist3
#define attlist4 RTI_attlist4
#define attlist5 RTI_attlist5
#define attlist6 RTI_attlist6
#define attlist7 RTI_attlist7
#define attlist8 RTI_attlist8
#define attlist9 RTI_attlist9
#define big2_byteToAscii RTI_big2_byteToAscii
#define big2_byteType RTI_big2_byteType
#define big2_charMatches RTI_big2_charMatches
#define big2_encoding RTI_big2_encoding
#define big2_isNameMin RTI_big2_isNameMin
#define big2_isNmstrtMin RTI_big2_isNmstrtMin
#define build_model RTI_build_model
#define build_node RTI_build_node
#define cdataSectionProcessor RTI_cdataSectionProcessor
#define checkCharRefNumber RTI_checkCharRefNumber
#define common RTI_common
#define condSect0 RTI_condSect0
#define condSect1 RTI_condSect1
#define condSect2 RTI_condSect2
#define contentProcessor RTI_contentProcessor
#define copyEntityTable RTI_copyEntityTable
#define declClose RTI_declClose
#define defineAttribute RTI_defineAttribute
#define destroyBindings RTI_destroyBindings
#define doCdataSection RTI_doCdataSection
#define doContent RTI_doContent
#define doctype0 RTI_doctype0
#define doctype1 RTI_doctype1
#define doctype2 RTI_doctype2
#define doctype3 RTI_doctype3
#define doctype4 RTI_doctype4
#define doctype5 RTI_doctype5
#define doIgnoreSection RTI_doIgnoreSection
#define doParseXmlDecl RTI_doParseXmlDecl
#define doProlog RTI_doProlog
#define dtdCopy RTI_dtdCopy
#define dtdCreate RTI_dtdCreate
#define dtdDestroy RTI_dtdDestroy
#define dtdReset RTI_dtdReset
#define element0 RTI_element0
#define element1 RTI_element1
#define element2 RTI_element2
#define element3 RTI_element3
#define element4 RTI_element4
#define element5 RTI_element5
#define element6 RTI_element6
#define element7 RTI_element7
#define encodings RTI_encodings
#define entity0 RTI_entity0
#define entity1 RTI_entity1
#define entity10 RTI_entity10
#define entity2 RTI_entity2
#define entity3 RTI_entity3
#define entity4 RTI_entity4
#define entity5 RTI_entity5
#define entity6 RTI_entity6
#define entity7 RTI_entity7
#define entity8 RTI_entity8
#define entity9 RTI_entity9
#define entityValueInitProcessor RTI_entityValueInitProcessor
#define entityValueProcessor RTI_entityValueProcessor
#define epilogProcessor RTI_epilogProcessor
#define error RTI_error
#define errorProcessor RTI_errorProcessor
#define externalEntityContentProcessor RTI_externalEntityContentProcessor
#define externalEntityInitProcessor RTI_externalEntityInitProcessor
#define externalEntityInitProcessor2 RTI_externalEntityInitProcessor2
#define externalEntityInitProcessor3 RTI_externalEntityInitProcessor3
#define externalParEntInitProcessor RTI_externalParEntInitProcessor
#define externalParEntProcessor RTI_externalParEntProcessor
#define externalSubset0 RTI_externalSubset0
#define externalSubset1 RTI_externalSubset1
#define findEncoding RTI_findEncoding
#define getAttributeId RTI_getAttributeId
#define getContext RTI_getContext
#define getElementType RTI_getElementType
#define getEncodingIndex RTI_getEncodingIndex
#define handleUnknownEncoding RTI_handleUnknownEncoding
#define hash RTI_hash
#define hashTableClear RTI_hashTableClear
#define hashTableDestroy RTI_hashTableDestroy
#define hashTableInit RTI_hashTableInit
#define hashTableIterInit RTI_hashTableIterInit
#define hashTableIterNext RTI_hashTableIterNext
#define ignoreSectionProcessor RTI_ignoreSectionProcessor
#define initializeEncoding RTI_initializeEncoding
#define initScan RTI_initScan
#define initScanContent RTI_initScanContent
#define initScanProlog RTI_initScanProlog
#define initUpdatePosition RTI_initUpdatePosition
#define internal_big2_encoding RTI_internal_big2_encoding
#define internal_big2_encoding_ns RTI_internal_big2_encoding_ns
#define internal_little2_encoding RTI_internal_little2_encoding
#define internal_little2_encoding_ns RTI_internal_little2_encoding_ns
#define internalSubset RTI_internalSubset
#define internal_utf8_encoding RTI_internal_utf8_encoding
#define internal_utf8_encoding_ns RTI_internal_utf8_encoding_ns
#define isNever RTI_isNever
#define isSpace RTI_isSpace
#define keyeq RTI_keyeq
#define KW_encoding RTI_KW_encoding
#define KW_ISO_8859_1 RTI_KW_ISO_8859_1
#define KW_no RTI_KW_no
#define KW_standalone RTI_KW_standalone
#define KW_US_ASCII RTI_KW_US_ASCII
#define KW_UTF_16 RTI_KW_UTF_16
#define KW_UTF_16BE RTI_KW_UTF_16BE
#define KW_UTF_16LE RTI_KW_UTF_16LE
#define KW_UTF_8 RTI_KW_UTF_8
#define KW_version RTI_KW_version
#define KW_yes RTI_KW_yes
#define latin1_encoding RTI_latin1_encoding
#define latin1_encoding_ns RTI_latin1_encoding_ns
#define latin1_toUtf16 RTI_latin1_toUtf16
#define latin1_toUtf8 RTI_latin1_toUtf8
#define little2_byteToAscii RTI_little2_byteToAscii
#define little2_byteType RTI_little2_byteType
#define little2_charMatches RTI_little2_charMatches
#define little2_encoding RTI_little2_encoding
#define little2_isNameMin RTI_little2_isNameMin
#define little2_isNmstrtMin RTI_little2_isNmstrtMin
#define lookup RTI_lookup
#define moveToFreeBindingList RTI_moveToFreeBindingList
#define nextScaffoldPart RTI_nextScaffoldPart
#define normal_encoding RTI_normal_encoding
#define normalizeLines RTI_normalizeLines
#define normalizePublicId RTI_normalizePublicId
#define notation0 RTI_notation0
#define notation1 RTI_notation1
#define notation2 RTI_notation2
#define notation3 RTI_notation3
#define notation4 RTI_notation4
#define parsePseudoAttribute RTI_parsePseudoAttribute
#define parserCreate RTI_parserCreate
#define parserInit RTI_parserInit
#define poolAppend RTI_poolAppend
#define poolAppendString RTI_poolAppendString
#define poolClear RTI_poolClear
#define poolCopyString RTI_poolCopyString
#define poolCopyStringN RTI_poolCopyStringN
#define poolDestroy RTI_poolDestroy
#define poolGrow RTI_poolGrow
#define poolInit RTI_poolInit
#define poolStoreString RTI_poolStoreString
#define processInternalParamEntity RTI_processInternalParamEntity
#define processXmlDecl RTI_processXmlDecl
#define prolog0 RTI_prolog0
#define prolog1 RTI_prolog1
#define prolog2 RTI_prolog2
#define prologInitProcessor RTI_prologInitProcessor
#define prologProcessor RTI_prologProcessor
#define reportComment RTI_reportComment
#define reportDefault RTI_reportDefault
#define reportProcessingInstruction RTI_reportProcessingInstruction
#define sb_byteToAscii RTI_sb_byteToAscii
#define sb_byteType RTI_sb_byteType
#define sb_charMatches RTI_sb_charMatches
#define setContext RTI_setContext
#define setElementTypePrefix RTI_setElementTypePrefix
#define storeAttributeValue RTI_storeAttributeValue
#define storeAtts RTI_storeAtts
#define storeEntityValue RTI_storeEntityValue
#define storeRawNames RTI_storeRawNames
#define streqci RTI_streqci
#define toAscii RTI_toAscii
#define unicode_byte_type RTI_unicode_byte_type
#define unknown_encoding RTI_unknown_encoding
#define unknown_isInvalid RTI_unknown_isInvalid
#define unknown_isName RTI_unknown_isName
#define unknown_isNmstrt RTI_unknown_isNmstrt
#define unknown_toUtf16 RTI_unknown_toUtf16
#define unknown_toUtf8 RTI_unknown_toUtf8
#define utf8_encoding RTI_utf8_encoding
#define utf8_encoding_ns RTI_utf8_encoding_ns
#define utf8_isInvalid2 RTI_utf8_isInvalid2
#define utf8_isInvalid3 RTI_utf8_isInvalid3
#define utf8_isInvalid4 RTI_utf8_isInvalid4
#define utf8_isName2 RTI_utf8_isName2
#define utf8_isName3 RTI_utf8_isName3
/*
CORE-9095: No need to define here. Defined in xmltok.c
#define utf8_isName4 RTI_utf8_isName4
*/
#define utf8_isNmstrt2 RTI_utf8_isNmstrt2
#define utf8_isNmstrt3 RTI_utf8_isNmstrt3
/*
CORE-9095: No need to define here. Defined in xmltok.c
#define utf8_isNmstrt4 RTI_utf8_isNmstrt4
*/
#define utf8_toUtf16 RTI_utf8_toUtf16
#define utf8_toUtf8 RTI_utf8_toUtf8


#define XML_AttlistDeclHandler RTI_XML_AttlistDeclHandler
#define XML_Bool RTI_XML_Bool
#define XML_Char RTI_XML_Char
#define XML_CharacterDataHandler RTI_XML_CharacterDataHandler
#define XML_CommentHandler RTI_XML_CommentHandler
#define XML_Content RTI_XML_Content
#define XML_Content_findDescendant RTI_XML_Content_findDescendant
#define XML_Content_Quant RTI_XML_Content_Quant
#define XML_Content_Type RTI_XML_Content_Type
#define XML_DefaultCurrent RTI_XML_DefaultCurrent
#define XML_DefaultHandler RTI_XML_DefaultHandler
#define XML_ElementDeclHandler RTI_XML_ElementDeclHandler
#define XML_Encoding RTI_XML_Encoding
#define XML_EndCdataSectionHandler RTI_XML_EndCdataSectionHandler
#define XML_EndDoctypeDeclHandler RTI_XML_EndDoctypeDeclHandler
#define XML_EndElementHandler RTI_XML_EndElementHandler
#define XML_EndNamespaceDeclHandler RTI_XML_EndNamespaceDeclHandler
#define XML_EntityDeclHandler RTI_XML_EntityDeclHandler
#define XML_Error RTI_XML_Error
#define XML_ErrorString RTI_XML_ErrorString
#define XML_Expat_Version RTI_XML_Expat_Version
#define XML_ExpatVersion RTI_XML_ExpatVersion
#define XML_ExpatVersionInfo RTI_XML_ExpatVersionInfo
#define XML_ExternalEntityParserCreate RTI_XML_ExternalEntityParserCreate
#define XML_ExternalEntityRefHandler RTI_XML_ExternalEntityRefHandler
#define XML_Feature RTI_XML_Feature
#define XML_FeatureEnum RTI_XML_FeatureEnum
#define XML_FreeContentModel RTI_XML_FreeContentModel
#define XML_GetBase RTI_XML_GetBase
#define XML_GetBuffer RTI_XML_GetBuffer
#define XML_GetCurrentByteCount RTI_XML_GetCurrentByteCount
#define XML_GetCurrentByteIndex RTI_XML_GetCurrentByteIndex
#define XML_GetCurrentColumnNumber RTI_XML_GetCurrentColumnNumber
#define XML_GetCurrentLineNumber RTI_XML_GetCurrentLineNumber
#define XML_GetErrorCode RTI_XML_GetErrorCode
#define XML_GetFeatureList RTI_XML_GetFeatureList
#define XML_GetIdAttributeIndex RTI_XML_GetIdAttributeIndex
#define XML_GetInputContext RTI_XML_GetInputContext
#define XML_GetParsingStatus RTI_XML_GetParsingStatus
#define XML_GetSpecifiedAttributeCount RTI_XML_GetSpecifiedAttributeCount
#define XML_LChar RTI_XML_LChar
#define XML_MemFree RTI_XML_MemFree
#define XML_MemMalloc RTI_XML_MemMalloc
#define XML_Memory_Handling_Suite RTI_XML_Memory_Handling_Suite
#define XML_MemRealloc RTI_XML_MemRealloc
#define XML_NotationDeclHandler RTI_XML_NotationDeclHandler
#define XML_NotStandaloneHandler RTI_XML_NotStandaloneHandler
#define XML_ParamEntityParsing RTI_XML_ParamEntityParsing
#define XML_Parse RTI_XML_Parse
#define XML_ParseBuffer RTI_XML_ParseBuffer
#define XML_Parser RTI_XML_Parser
#define XML_ParserCreate RTI_XML_ParserCreate
#define XML_ParserCreate_MM RTI_XML_ParserCreate_MM
#define XML_ParserCreateNS RTI_XML_ParserCreateNS
#define XML_ParserFree RTI_XML_ParserFree
#define XML_ParserReset RTI_XML_ParserReset
#define XML_ParserStruct RTI_XML_ParserStruct
#define XML_Parsing RTI_XML_Parsing
#define XML_ParsingStatus RTI_XML_ParsingStatus
#define XML_ProcessingInstructionHandler RTI_XML_ProcessingInstructionHandler
#define XML_ResumeParser RTI_XML_ResumeParser
#define XML_SetAttlistDeclHandler RTI_XML_SetAttlistDeclHandler
#define XML_SetBase RTI_XML_SetBase
#define XML_SetCdataSectionHandler RTI_XML_SetCdataSectionHandler
#define XML_SetCharacterDataHandler RTI_XML_SetCharacterDataHandler
#define XML_SetCommentHandler RTI_XML_SetCommentHandler
#define XML_SetDefaultHandler RTI_XML_SetDefaultHandler
#define XML_SetDefaultHandlerExpand RTI_XML_SetDefaultHandlerExpand
#define XML_SetDoctypeDeclHandler RTI_XML_SetDoctypeDeclHandler
#define XML_SetElementDeclHandler RTI_XML_SetElementDeclHandler
#define XML_SetElementHandler RTI_XML_SetElementHandler
#define XML_SetEncoding RTI_XML_SetEncoding
#define XML_SetEndCdataSectionHandler RTI_XML_SetEndCdataSectionHandler
#define XML_SetEndDoctypeDeclHandler RTI_XML_SetEndDoctypeDeclHandler
#define XML_SetEndElementHandler RTI_XML_SetEndElementHandler
#define XML_SetEndNamespaceDeclHandler RTI_XML_SetEndNamespaceDeclHandler
#define XML_SetEntityDeclHandler RTI_XML_SetEntityDeclHandler
#define XML_SetExternalEntityRefHandler RTI_XML_SetExternalEntityRefHandler
#define XML_SetExternalEntityRefHandlerArg RTI_XML_SetExternalEntityRefHandlerArg
#define XML_SetHashSalt RTI_XML_SetHashSalt
#define XML_SetNamespaceDeclHandler RTI_XML_SetNamespaceDeclHandler
#define XML_SetNotationDeclHandler RTI_XML_SetNotationDeclHandler
#define XML_SetNotStandaloneHandler RTI_XML_SetNotStandaloneHandler
#define XML_SetParamEntityParsing RTI_XML_SetParamEntityParsing
#define XML_SetProcessingInstructionHandler RTI_XML_SetProcessingInstructionHandler
#define XML_SetReturnNSTriplet RTI_XML_SetReturnNSTriplet
#define XML_SetSkippedEntityHandler RTI_XML_SetSkippedEntityHandler
#define XML_SetStartCdataSectionHandler RTI_XML_SetStartCdataSectionHandler
#define XML_SetStartDoctypeDeclHandler RTI_XML_SetStartDoctypeDeclHandler
#define XML_SetStartElementHandler RTI_XML_SetStartElementHandler
#define XML_SetStartNamespaceDeclHandler RTI_XML_SetStartNamespaceDeclHandler
#define XML_SetUnknownEncodingHandler RTI_XML_SetUnknownEncodingHandler
#define XML_SetUnparsedEntityDeclHandler RTI_XML_SetUnparsedEntityDeclHandler
#define XML_SetUserData RTI_XML_SetUserData
#define XML_SetXmlDeclHandler RTI_XML_SetXmlDeclHandler
#define XML_SkippedEntityHandler RTI_XML_SkippedEntityHandler
#define XML_StartCdataSectionHandler RTI_XML_StartCdataSectionHandler
#define XML_StartDoctypeDeclHandler RTI_XML_StartDoctypeDeclHandler
#define XML_StartElementHandler RTI_XML_StartElementHandler
#define XML_StartNamespaceDeclHandler RTI_XML_StartNamespaceDeclHandler
#define XML_Status RTI_XML_Status
#define XML_StopParser RTI_XML_StopParser
#define XML_UnknownEncodingHandler RTI_XML_UnknownEncodingHandler
#define XML_UnparsedEntityDeclHandler RTI_XML_UnparsedEntityDeclHandler
#define XML_UseForeignDTD RTI_XML_UseForeignDTD
#define XML_UseParserAsHandlerArg RTI_XML_UseParserAsHandlerArg
#define XML_XmlDeclHandler RTI_XML_XmlDeclHandler
#define XML_SetBillionLaughsAttackProtectionActivationThreshold RTI_XML_SetBillionLaughsAttackProtectionActivationThreshold
#define XML_SetBillionLaughsAttackProtectionMaximumAmplification RTI_XML_SetBillionLaughsAttackProtectionMaximumAmplification

#define XmlGetUtf16InternalEncoding RTI_XmlGetUtf16InternalEncoding
#define XmlGetUtf8InternalEncoding RTI_XmlGetUtf8InternalEncoding
#define XmlInitEncoding RTI_XmlInitEncoding
#define XmlInitUnknownEncoding RTI_XmlInitUnknownEncoding
#ifdef XML_NS
  #define XmlInitUnknownEncodingNS RTI_XmlInitUnknownEncodingNS
#endif
#define XmlParseXmlDecl RTI_XmlParseXmlDecl
#define XmlPrologStateInit RTI_XmlPrologStateInit
#define XmlPrologStateInitExternalEntity RTI_XmlPrologStateInitExternalEntity
#define XmlSizeOfUnknownEncoding RTI_XmlSizeOfUnknownEncoding
#define XmlUtf16Encode RTI_XmlUtf16Encode
#define XmlUtf8Encode RTI_XmlUtf8Encode

#define big2_attributeValueTok RTI_big2_attributeValueTok
#define big2_cdataSectionTok RTI_big2_cdataSectionTok
#define big2_charRefNumber RTI_big2_charRefNumber
#define big2_checkPiTarget RTI_big2_checkPiTarget
#define big2_contentTok RTI_big2_contentTok
#define big2_entityValueTok RTI_big2_entityValueTok
#define big2_getAtts RTI_big2_getAtts
#define big2_ignoreSectionTok RTI_big2_ignoreSectionTok
#define big2_isPublicId RTI_big2_isPublicId
#define big2_nameLength RTI_big2_nameLength
#define big2_nameMatchesAscii RTI_big2_nameMatchesAscii
#define big2_predefinedEntityName RTI_big2_predefinedEntityName
#define big2_prologTok RTI_big2_prologTok
#define big2_sameName RTI_big2_sameName
#define big2_scanComment RTI_big2_scanComment
#define big2_scanLit RTI_big2_scanLit
#define big2_scanPercent RTI_big2_scanPercent
#define big2_scanPi RTI_big2_scanPi
#define big2_scanRef RTI_big2_scanRef
#define big2_skipS RTI_big2_skipS
#define big2_toUtf16 RTI_big2_toUtf16
#define big2_toUtf8 RTI_big2_toUtf8
#define big2_updatePosition RTI_big2_updatePosition


#define little2_attributeValueTok RTI_little2_attributeValueTok
#define little2_cdataSectionTok RTI_little2_cdataSectionTok
#define little2_charRefNumber RTI_little2_charRefNumber
#define little2_checkPiTarget RTI_little2_checkPiTarget
#define little2_contentTok RTI_little2_contentTok
#define little2_entityValueTok RTI_little2_entityValueTok
#define little2_getAtts RTI_little2_getAtts
#define little2_ignoreSectionTok RTI_little2_ignoreSectionTok
#define little2_isPublicId RTI_little2_isPublicId
#define little2_nameLength RTI_little2_nameLength
#define little2_nameMatchesAscii RTI_little2_nameMatchesAscii
#define little2_predefinedEntityName RTI_little2_predefinedEntityName
#define little2_prologTok RTI_little2_prologTok
#define little2_sameName RTI_little2_sameName
#define little2_scanComment RTI_little2_scanComment
#define little2_scanLit RTI_little2_scanLit
#define little2_scanPercent RTI_little2_scanPercent
#define little2_scanPi RTI_little2_scanPi
#define little2_scanRef RTI_little2_scanRef
#define little2_skipS RTI_little2_skipS
#define little2_toUtf16 RTI_little2_toUtf16
#define little2_toUtf8 RTI_little2_toUtf8
#define little2_updatePosition RTI_little2_updatePosition

#define normal_attributeValueTok RTI_normal_attributeValueTok
#define normal_cdataSectionTok RTI_normal_cdataSectionTok
#define normal_charRefNumber RTI_normal_charRefNumber
#define normal_checkPiTarget RTI_normal_checkPiTarget
#define normal_contentTok RTI_normal_contentTok
#define normal_entityValueTok RTI_normal_entityValueTok
#define normal_getAtts RTI_normal_getAtts
#define normal_ignoreSectionTok RTI_normal_ignoreSectionTok
#define normal_isPublicId RTI_normal_isPublicId
#define normal_nameLength RTI_normal_nameLength
#define normal_nameMatchesAscii RTI_normal_nameMatchesAscii
#define normal_predefinedEntityName RTI_normal_predefinedEntityName
#define normal_prologTok RTI_normal_prologTok
#define normal_sameName RTI_normal_sameName
#define normal_scanComment RTI_normal_scanComment
#define normal_scanLit RTI_normal_scanLit
#define normal_scanPercent RTI_normal_scanPercent
#define normal_scanPi RTI_normal_scanPi
#define normal_scanRef RTI_normal_scanRef
#define normal_skipS RTI_normal_skipS
#define normal_updatePosition RTI_normal_updatePosition

#define _INTERNAL_trim_to_complete_utf8_characters RTI_INTERNAL_trim_to_complete_utf8_characters

#define unsignedCharToPrintable RTI_unsignedCharToPrintable
#define testingAccountingGetCountBytesDirect RTI_testingAccountingGetCountBytesDirect
#define testingAccountingGetCountBytesIndirect RTI_testingAccountingGetCountBytesIndirect

#endif /* EXPAT_USE_RTI_NAMESPACE */

#endif

