/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)rtixml_extension_impl.h    generated by: makeheader    Sat Mar  9 09:37:50 2024
 *
 *		built from:	extension_impl.ifc
 */

#ifndef rtixml_extension_impl_h
#define rtixml_extension_impl_h


  #ifdef __cplusplus
      extern "C" {
  #endif


struct RTIXMLExtensionClass { 
    /*i @brief Init flag */
    int _init;

    /*i 
      @brief Tag name 
    */
    char * _tagName;

    /*i
      @brief User data
    */
    void * _userData;

    /*i
      @brief Indicates if duplicate objects are allowed
    */
    RTIBool allowDuplicatedObjects;

    /*i
      @brief Indicates if the class is a root class
    */
    RTIBool isRoot;

    /*i 
      @brief Function to call when a start tag is  found within an object of this RTIXMLExtensionClass. 
    */
    RTIXMLExtensionClassOnStartTagFunction onStartTagFcn;

    /*i 
      @brief Function to call when a end tag is found within an object of this RTIXMLExtensionClass.. 
    */
    RTIXMLExtensionClassOnEndTagFunction onEndTagFcn;

    /*i 
      @brief Function to call when the start tag is equal to the tagName. 
    */
    RTIXMLExtensionClassNewObjectFunction newObjectFcn;

    /*i 
      @brief Function to call when we want to delete an object. 
    */
    RTIXMLExtensionClassDeleteObjectFunction deleteObjectFcn;

    /*i 
      @brief Function to call when we want to save an object. 
    */
    RTIXMLExtensionClassSaveObjectFunction saveObjectFcn;
};


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* rtixml_extension_impl_h */
