/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)rtixml_log.h    generated by: makeheader    Sat Mar  9 09:37:50 2024
 *
 *		built from:	log.ifc
 */

#ifndef rtixml_log_h
#define rtixml_log_h


  #ifndef rtixml_dll_h
    #include "rtixml/rtixml_dll.h"
  #endif
  #ifndef log_common_h
    #include "log/log_common.h"
  #endif
  #ifdef __cplusplus
      extern "C" {
  #endif


  /*e \ingroup RTIXMLLog
    Submodule ID for Parser submodule
  */
  #define SUBMODULE_RTIXML_PARSER (0x1000)


  /*e \ingroup RTIXMLLog
    Mask for turning on logging for only the parser submodule
  */
  #define RTIXML_SUBMODULE_MASK_PARSER (0x0001)
  /*e \ingroup RTIXMLLog
    Mask for turning on logging for all submoudles
  */
  #define RTIXML_SUBMODULE_MASK_ALL RTI_LOG_SUBMODULE_MASK_ALL

extern RTIXMLDllExport
void RTIXMLLog_setDependencyInstrumentationMask(RTILogBitmap verbosity);

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_BASE_NOT_FOUND_s;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_PARSE_FAILURE_ss;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_PARSE_FAILURE_s;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_PARSE_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_PARSE_FAILURE_dss;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_PARSE_FILE_FAILURE_s;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_TAG_CREATION_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_DTD_PARSER_PARSE_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_UNEXPECTED_TAG_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_TAG_NOT_SUPPORTED_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_UNEXPECTED_ATTRIBUTE_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_UNEXPECTED_ATTRIBUTE_VALUE_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_UNEXPECTED_TEXT_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_REQUIRED_ATTRIBUTE_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INVALID_ATTRIBUTE_INT_VALUE_ddssdd;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INVALID_ATTRIBUTE_INT_VALUE_W_UNBOUNDED_ddssddd;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INVALID_ATTRIBUTE_UINT_VALUE_dussuu;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INVALID_INT_VALUE_IN_EXPRESSION_ddsdd;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INVALID_INT_VALUE_IN_EXPRESSION_W_UNBOUNDED_ddsddd;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INVALID_UINT_VALUE_IN_EXPRESSION_dusuu;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INTERNAL_FAILURE_s;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_INTERNAL_FAILURE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_ILLEGAL_VALUE_ds;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_ENV_VAR_NOT_DEFINED_s;

extern RTIXMLDllVariable const struct RTILogMessage
RTIXML_LOG_PARSER_DUPLICATE_TAG_PARSE_FAILURE_dsd;


  #ifdef __cplusplus
    }	/* extern "C" */
  #endif

#endif /* rtixml_log_h */
