/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)rtixmlutils_object.h    generated by: makeheader    Sat Mar  9 10:24:40 2024
 *
 *		built from:	object.ifc
 */

#ifndef rtixmlutils_object_h
#define rtixmlutils_object_h



#include "rtixmlutils/rtixmlutils_dll.h"
#include "osapi/osapi_type.h"

#ifdef __cplusplus
    extern "C" {
#endif


typedef enum {
    RTIXMLUTILS_OBJECT_VALUE_TEXT_CONTENT,
    RTIXMLUTILS_OBJECT_VARIABLE_TEXT_CONTENT
} RTIXMLUTILSObjectTextContentKind;


struct RTIXMLUTILSObject;


#define RTIXMLUTILS_OBJECT_ANNOTATION_TAG_NAME ("annotation")
#define RTIXMLUTILS_OBJECT_DOCUMENTATION_TAG_NAME ("documentation")
#define RTIXMLUTILS_OBJECT_NODE_NAME_LENGTH_MAX (256)
#define RTIXMLUTILS_OBJECT_NAME_SEPARATOR ("::")
#define RTIXMLUTILS_OBJECT_FILE_PATH_PI_NAME ("rti-filepath")
#define RTIXMLUTILS_OBJECT_END_OF_FRAGMENT_PI_CONTENT ("END-OF-XML-FRAGMENT")
#define RTIXMLUTILS_PARSER_URL_LIST_SEPARATOR   (";")
#define RTIXMLUTILS_PARSER_URL_GROUP_SEPARATOR  ("|")
#define RTIXMLUTILS_PARSER_URL_GROUP_START  ("[")
#define RTIXMLUTILS_PARSER_URL_GROUP_END  ("]")
#define RTIXMLUTILS_PARSER_URL_STRING_SCHEME  ("str://")
#define RTIXMLUTILS_PARSER_URL_FILE_SCHEME  ("file://")
#define RTIXMLUTILS_TRANSFORMER_PARAMS_LENGTH_MAX  (64)

extern RTIXMLUTILSDllVariable
const char * RTIXMLUTILS_OBJECT_FILE_UNKNOWN_URL;

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getName(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
const char *RTIXMLUTILSObject_getTagName(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getAttribute(
        struct RTIXMLUTILSObject *self,
        const char *attributeName);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_getNextAttribute(
        struct RTIXMLUTILSObject *self,
        const char **name,
        const char **value);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getText(struct RTIXMLUTILSObject * self);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_selectText(
        struct RTIXMLUTILSObject *self,
        RTIXMLUTILSObjectTextContentKind contentKind);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getFullyQualifiedName(struct RTIXMLUTILSObject * self);

extern RTIXMLUTILSDllExport
RTI_INT32 RTIXMLUTILSObject_getLineNumber(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getUrl(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_getParent(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
int RTIXMLUTILSObject_getChildCount(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_getFirstChild(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject *RTIXMLUTILSObject_getNextSibling(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject *RTIXMLUTILSObject_getPrevSibling(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_getFirstChildWithTag(
        struct RTIXMLUTILSObject *self,
        const char *tagName);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_getFirstDescendantWithTag(
        struct RTIXMLUTILSObject *self,
        const char *tagName);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_getNextDescendantWithTag(
        struct RTIXMLUTILSObject *self, 
        struct RTIXMLUTILSObject *prevDescendant, 
        const char *tagName);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_getNextSiblingWithTag(
        struct RTIXMLUTILSObject *self,
        const char *tagName);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject *RTIXMLUTILSObject_lookUpChild(
        struct RTIXMLUTILSObject *self,
        const char *name);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject *RTIXMLUTILSObject_lookUp(
        struct RTIXMLUTILSObject *self,
        const char *name);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject *RTIXMLUTILSObject_getRoot(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSObject_setUserData(
        struct RTIXMLUTILSObject *self,
        void *userData);

extern RTIXMLUTILSDllExport
void * RTIXMLUTILSObject_getUserData(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSObject_unlink(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_copyAsChild(
        struct RTIXMLUTILSObject *self,
        struct RTIXMLUTILSObject *element);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject *  RTIXMLUTILSObject_copyAsChildWithProcessingInstruction(
        struct RTIXMLUTILSObject *self,
        struct RTIXMLUTILSObject *element,
        char *processingInstruction,
        char *processingInstructionData);

extern RTIXMLUTILSDllExport
struct RTIXMLUTILSObject * RTIXMLUTILSObject_copy(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_toStringWithParams(
        struct RTIXMLUTILSObject * self,
        char **outputBuffer,
        unsigned int *outputBufferLength,
        unsigned int outputBufferOffset,
        RTIBool prettyPrint);

extern RTIXMLUTILSDllExport
char * RTIXMLUTILSObject_toString(struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_equalAttributes(
        struct RTIXMLUTILSObject *self,
        struct RTIXMLUTILSObject *other);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_equals(
        struct RTIXMLUTILSObject *self,
        struct RTIXMLUTILSObject *other);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getAnnotationDocText(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_isText(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_setFilePathFragment(
        struct RTIXMLUTILSObject *self,
        const char *fileName);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_getFilePath(
        struct RTIXMLUTILSObject *self);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_setAttribute(
        struct RTIXMLUTILSObject *self,
        const char *name,
        const char *value);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSObject_removeAttribute(
        struct RTIXMLUTILSObject *self,
        const char *name);

extern RTIXMLUTILSDllExport
RTIBool RTIXMLUTILSObject_addProcessingInstruction(
        struct RTIXMLUTILSObject *self,
        const char *name,
        const char *content);

extern RTIXMLUTILSDllExport
const char * RTIXMLUTILSObject_lookUpProcessingInstruction(
        struct RTIXMLUTILSObject *self,
        const char *name);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSObject_setTagName(
        struct RTIXMLUTILSObject *self,
        const char *tagName);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSObject_setName(
        struct RTIXMLUTILSObject *self,
        const char *name);

extern RTIXMLUTILSDllExport
void RTIXMLUTILSObject_setText(
        struct RTIXMLUTILSObject *self,
        const char *elementText);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* rtixmlutils_object_h */
