/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)transport_meta.h    generated by: makeheader    Sat Mar  9 09:38:06 2024
 *
 *		built from:	meta.ifc
 */

#ifndef transport_meta_h
#define transport_meta_h


  #ifndef transport_dll_h
    #include "transport/transport_dll.h"
  #endif
  #ifndef transport_interface_h
    #include "transport/transport_interface.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

typedef struct NDDS_Transport_Meta_impl NDDS_Transport_Meta; /* forward declare to appease compiler */

extern NDDS_Transport_DllExport 
NDDS_Transport_Meta *NDDS_Transport_Meta_new(
    NDDS_Transport_Plugin*                       base_transport_in,  
    NDDS_Transport_Plugin*                       mock_transport_before_in,
    NDDS_Transport_Plugin*                       mock_transport_after_in);

extern NDDS_Transport_DllExport NDDS_Transport_Plugin*  
NDDS_Transport_Meta_get_base_transport(
    NDDS_Transport_Meta      *self);

extern NDDS_Transport_DllExport NDDS_Transport_Plugin* 
NDDS_Transport_Meta_get_mock_transport_before(
    NDDS_Transport_Meta      *self);

extern NDDS_Transport_DllExport NDDS_Transport_Plugin* 
NDDS_Transport_Meta_get_mock_transport_after(
    NDDS_Transport_Meta      *self);


#define NDDS_TRANSPORT_TRACE_CLASS_NAME		"trace"


#define NDDS_TRANSPORT_CLASSID_TRACE  (NDDS_TRANSPORT_CLASSID_RESERVED_RANGE-1)


#define NDDS_TRANSPORT_TRACE_ADDRESS_BIT_COUNT  (0)


#define NDDS_TRANSPORT_TRACE_PROPERTIES_BITMAP_DEFAULT (0)


#define NDDS_TRANSPORT_TRACE_GATHER_SEND_BUFFER_COUNT_MAX_DEFAULT \
                (NDDS_TRANSPORT_PROPERTY_GATHER_SEND_BUFFER_COUNT_MIN)


#define NDDS_TRANSPORT_TRACE_MESSAGE_SIZE_MAX_DEFAULT (9216)


#define NDDS_TRANSPORT_TRACE_PROPERTY_DEFAULT \
  { \
    NDDS_TRANSPORT_CLASSID_TRACE, \
    NDDS_TRANSPORT_TRACE_ADDRESS_BIT_COUNT, \
    NDDS_TRANSPORT_TRACE_PROPERTIES_BITMAP_DEFAULT, \
    NDDS_TRANSPORT_TRACE_GATHER_SEND_BUFFER_COUNT_MAX_DEFAULT, \
    NDDS_TRANSPORT_TRACE_MESSAGE_SIZE_MAX_DEFAULT, \
    NULL, \
    0, /* allow_interfaces_list */ \
    NULL, \
    0, /* deny_interfaces_list */ \
    NULL, \
    0, /* allow_multicast_interfaces_list */ \
    NULL, \
    0,                               /* deny_multicast_interfaces_list */ \
    NDDS_TRANSPORT_UUID_UNKNOWN,     /* transport_uuid */ \
    NULL,                            /* domain_participant_ptr */ \
    NULL,                            /* domain_participant_forwarder */ \
    NULL,                            /* thread_name_prefix */ \
    NDDS_TRANSPORT_LENGTH_UNLIMITED, /* max_interface_count */ \
    RTI_FALSE /* ignore_participant_index_for_initial_peers */ \
  }

typedef struct {
    NDDS_Transport_Plugin parent;     /* must be first entry! */

    /* We use a generic NDDS_Transport property for this transport */
    struct NDDS_Transport_Property_t     _property;
    
    RTI_INT32 _count_send;
    RTI_INT32 _count_receive_rEA;
    RTI_INT32 _count_return_loaned_buffer_rEA; 
    RTI_INT32 _count_unblock_receive_rrEA; 
    RTI_INT32 _count_create_recvresource_rrEA; 
    RTI_INT32 _count_destroy_recvresource_rrEA; 
    RTI_INT32 _count_share_recvresource_rrEA; 
    RTI_INT32 _count_unshare_recvresource_rrEA;
    RTI_INT32 _count_create_sendresource_srEA;
    RTI_INT32 _count_destroy_sendresource_srEA;
    RTI_INT32 _count_share_sendresource_srEA;
    RTI_INT32 _count_unshare_sendresource_srEA;
    RTI_INT32 _count_get_class_name_cEA;
    RTI_INT32 _count_string_to_address_cEA;
    RTI_INT32 _count_get_receive_interfaces_cEA;
    RTI_INT32 _count_get_transport_receive_context;
    RTI_INT32 _count_get_transport_send_context;
    RTI_INT32 _count_register_listener_cEA; 
    RTI_INT32 _count_delete_cEA;
} NDDS_Transport_Trace;

extern NDDS_Transport_DllExport
NDDS_Transport_Trace * NDDS_Transport_Trace_new(void);

extern NDDS_Transport_DllExport RTI_INT32 
NDDS_Transport_Trace_get_count__send(NDDS_Transport_Trace* self);

extern NDDS_Transport_DllExport void 
NDDS_Transport_Trace_set_count__send(NDDS_Transport_Trace* self, RTI_INT32 count);

extern NDDS_Transport_DllExport RTI_INT32 
NDDS_Transport_Trace_get_count__receive_rEA(NDDS_Transport_Trace* self);

extern NDDS_Transport_DllExport void 
NDDS_Transport_Trace_set_count__receive_rEA(NDDS_Transport_Trace* self, RTI_INT32 count);

extern NDDS_Transport_DllExport RTI_INT32 
NDDS_Transport_Trace_get_count__get_receive_interfaces_cEA(NDDS_Transport_Trace* self);

extern NDDS_Transport_DllExport void
NDDS_Transport_Trace_set_count__get_receive_interfaces_cEA(NDDS_Transport_Trace* self, RTI_INT32 count);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* transport_meta_h */
