/*
 * (c) Copyright, Real-Time Innovations, 2021.
 * All rights reserved.
 * No duplications, whole or partial, manual or electronic, may be made
 * without express written permission.  Any such copies, or
 * revisions thereof, must display this notice unaltered.
 * This code contains trade secrets of Real-Time Innovations, Inc.
 *
 * Description
 * -----------
 * Strictly for Windows DLL linkage resolution
 */


#ifndef wsdds_dll_h
#define wsdds_dll_h

#if defined(RTI_WIN32) || defined(RTI_WINCE)
  #if defined(RTI_wsdds_DLL_EXPORT)
    #define WSDDSDllExport __declspec(dllexport)
  #else
    #define WSDDSDllExport
  #endif /* RTI_wsdds_DLL_EXPORT */

  #if defined(RTI_wsdds_DLL_VARIABLE)
    #if defined(RTI_wsdds_DLL_EXPORT)
      #define WSDDSDllVariable __declspec(dllexport)
    #else
      #define WSDDSDllVariable __declspec(dllimport)
    #endif /* RTI_wsdds_DLL_EXPORT */
  #else
    #define WSDDSDllVariable
  #endif /* RTI_wsdds_DLL_VARIABLE */
#else
  #define WSDDSDllExport
  #define WSDDSDllVariable
#endif /* RTI_WIN32 || RTI_WINCE */


#endif /* webintegrationservice_dll_h */